﻿if not HCoold then return false end
local AceGUI = LibStub("AceGUI-3.0")
local L = HCoold:GetLocale()
local spells = {} -- spells that we can track by system
local spec_spells = {} -- spells that are uniq for each spec of class
local class_talents = {} -- talents for each class
local list_talents = {}
local sybiosis_gain_druid = {}
local sybiosis_gain_raid = {}

--[[
GetSpellInfo
GetSpellLink
GameTooltip
StaticPopupDialogs
StaticPopup_Show
]]--

do -- generate spells list
	do -- generate spells
		local type1 = {------ type == 1  аура на -дамаг +хил
			{ -- Demoralizing Shout http://www.wowhead.com/spell=1160
				spellID = 1160,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 60,
				class = "WARRIOR",
				cast_time = 8,
				quality = 1,
			},
			{ -- Aura Mastery http://www.wowhead.com/spell=31821
				spellID = 31821,
				class = "PALADIN",
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 1 },
				CD = 180,
				cast_time = 6,
				quality = 1,
			},
			{ -- Power Word: Barrier http://www.wowhead.com/spell=62618
				spellID = 62618,
				class = "PRIEST",
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 1 },
				CD = 180,
				cast_time = 10,
				quality = 1,
			},
            { -- Spirit Link Totem http://www.wowhead.com/spell=98008
				spellID = 98008,
				class = "SHAMAN",
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 6,
				quality = 3,
			},
            { -- Commanding Shout http://www.wowhead.com/spell=97462
				spellID = 97462,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 180,
				class = "WARRIOR",
				cast_time = 10,
				quality = 1,
			},
		}
		local type2 = {------ type == 2 аое хил
            { -- Divine Hymn http://www.wowhead.com/spell=64843
				spellID = 64843,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 2 },
				class = "PRIEST",
				quality = 3,
				cast_time = 8,
			},
            { -- Tranquility http://www.wowhead.com/spell=740
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 4 },
				class = "DRUID",
				quality = 3,
				cast_time = 8,
			},
            { -- Revival http://www.wowhead.com/spell=115310
				spellID = 115310,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 180,
				class = "MONK",
				quality = 1,
			},
            { -- Healing Tide Totem http://www.wowhead.com/spell=108280
				spellID = 108280,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 10,
				class = "SHAMAN",
				quality = 1,
			},
		}
		local type3 = {------ type == 3 на ману
		}
		local type4 = {------ type == 4  личный кд
            { -- Zen Meditation http://www.wowhead.com/spell=115176
                spellID = 115176,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 1,  },
                CD = 300,
                class = "MONK",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Dispersion http://www.wowhead.com/spell=47585
                spellID = 47585,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 3,  },
                CD = 120,
                class = "PRIEST",
                cast_time = 6,
                quality = 1,
                -- trigger = {},
            },
            { -- Last Stand http://www.wowhead.com/spell=12975
                spellID = 12975,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 3,  },
                CD = 180,
                class = "WARRIOR",
                cast_time = 15,
                quality = 1,
                -- trigger = {},
            },
            { -- Die by the Sword http://www.wowhead.com/spell=118038
                spellID = 118038,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 1,  },
                CD = 180,
                class = "WARRIOR",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Shield Wall http://www.wowhead.com/spell=871
                spellID = 871,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 3,  },
                CD = 240,
                class = "WARRIOR",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Cloak of Shadows http://www.wowhead.com/spell=31224
                spellID = 31224,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 90,
                class = "ROGUE",
                cast_time = 5,
                quality = 1,
                -- trigger = {},
            },
            { -- Evasion http://www.wowhead.com/spell=5277
                spellID = 5277,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 1, 3,  },
                CD = 120,
                class = "ROGUE",
                cast_time = 10,
                quality = 1,
                -- trigger = {},
            },
            { -- Ice Block http://www.wowhead.com/spell=45438
                spellID = 45438,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 300,
                class = "MAGE",
                cast_time = 10,
                quality = 1,
                -- trigger = {},
            },
            { -- Barkskin http://www.wowhead.com/spell=22812
                spellID = 22812,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 1, 3, 4,  },
                CD = 60,
                class = "DRUID",
                cast_time = 12,
                quality = 1,
                -- trigger = {},
            },
            { -- Unending Resolve http://www.wowhead.com/spell=104773
                spellID = 104773,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 180,
                class = "WARLOCK",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Ardent Defender http://www.wowhead.com/spell=31850
                spellID = 31850,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 2,  },
                CD = 120,
                class = "PALADIN",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Divine Shield http://www.wowhead.com/spell=642
                spellID = 642,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 300,
                class = "PALADIN",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Guardian of Ancient Kings http://www.wowhead.com/spell=86659
                spellID = 86659,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 2,  },
                CD = 300,
                class = "PALADIN",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Touch of Karma http://www.wowhead.com/spell=122470
                spellID = 122470,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 3,  },
                CD = 90,
                class = "MONK",
                cast_time = 10,
                quality = 1,
                -- trigger = {},
            },
            { -- Fortifying Brew http://www.wowhead.com/spell=115203
                spellID = 115203,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 1,  },
                CD = 420,
                class = "MONK",
                cast_time = 15,
                quality = 1,
                -- trigger = {},
            },
            { -- Icebound Fortitude http://www.wowhead.com/spell=48792
                spellID = 48792,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 2, 3,  },
                CD = 180,
                class = "DEATHKNIGHT",
                cast_time = 8,
                quality = 1,
                -- trigger = {},
            },
            { -- Vampiric Blood http://www.wowhead.com/spell=55233
                spellID = 55233,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 1,  },
                CD = 90,
                class = "DEATHKNIGHT",
                cast_time = 10,
                quality = 1,
                -- trigger = {},
            },
		}
		local type5 = {------ type == 5  точечный кд
            { -- Guardian Spirit http://www.wowhead.com/spell=47788
                spellID = 47788,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 2,  },
                CD = 240,
                class = "PRIEST",
                cast_time = 10,
                quality = 3,
                -- trigger = {},
            },
            { -- Pain Suppression http://www.wowhead.com/spell=33206
                spellID = 33206,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 1,  },
                CD = 240,
                class = "PRIEST",
                cast_time = 8,
                quality = 3,
                -- trigger = {},
            },
            { -- Ironbark http://www.wowhead.com/spell=102342
                spellID = 102342,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 4,  },
                CD = 90,
                class = "DRUID",
                cast_time = 12,
                quality = 1,
                -- trigger = {},
            },
            { -- Life Cocoon http://www.wowhead.com/spell=116849
                spellID = 116849,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 2,  },
                CD = 180,
                class = "MONK",
                cast_time = 12,
                quality = 1,
                -- trigger = {},
            },
		}
		local type6 = {------ type == 6  кд на +дамаг
            { -- Army of the Dead http://www.wowhead.com/spell=42650
                spellID = 42650,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 3,  },
                CD = 600,
                class = "DEATHKNIGHT",
                cast_time = 44,
                quality = 1,
                -- trigger = {},
            },
            { -- Heroism http://www.wowhead.com/spell=2825
                spellID = 2825,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 300,
                class = "SHAMAN",
                cast_time = 40,
                quality = 3,
                trigger = { 32182, },
            },
            { -- Time Warp http://www.wowhead.com/spell=80353
                spellID = 80353,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 300,
                class = "MAGE",
                cast_time = 40,
                quality = 3,
                -- trigger = {},
            },
            { -- Summon Infernal http://www.wowhead.com/spell=1122
                spellID = 1122,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 180,
                class = "WARLOCK",
                cast_time = 0,
                quality = 1,
                -- trigger = {},
            },
		}
		local type7 = {------ type == 7  возрождения -- SPELL_RESURRECT  ????
            { -- Rebirth http://www.wowhead.com/spell=20484
                spellID = 20484,
                succ = "SPELL_RESURRECT",
                specs = { 0,  },
                CD = 600,
                class = "DRUID",
                quality = 3,
                -- trigger = {},
            },
            { -- Raise Ally http://www.wowhead.com/spell=61999
                spellID = 61999,
                succ = "SPELL_CAST_SUCCESS",
                specs = { 0,  },
                CD = 600,
                class = "DEATHKNIGHT",
                quality = 2,
                -- trigger = {},
            },
            { -- Soulstone http://www.wowhead.com/spell=20707
                spellID = 20707,
                succ = { "SPELL_CAST_START" }, --{ "SPELL_RESURRECT", "SPELL_AURA_APPLIED" },
                specs = { 0,  },
                CD = 600,
                class = "WARLOCK",
                quality = 1,
                -- trigger = {},
            },
		}
		local type8 = {------ type == 8  прочее
			----------------- Шаманы
			{ -- Spirit walk (энх фридом)
				spellID = 58875,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 60,
				class = "SHAMAN",
				cast_time = 15,
				quality = 1,
			},
			{ -- благосклонность предков (касты на ходу у шамана)
				spellID = 79206,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "SHAMAN",
				cast_time = 15,
				quality = 1,
			},
			{ -- очищение духа (не рестор шаман)
				spellID = 51886,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 8,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- очищение духа (рестор шаман)
				spellID = 77130,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 8,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- пронизывающий ветер (сбитие каста шаман)
				spellID = 57994,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 12,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- сглаз (лягушка шаман)
				spellID = 51514,
				succ = {"SPELL_AURA_REFRESH", "SPELL_AURA_APPLIED", },
				specs = { 0 },
				CD = 45,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- гром и молния элем
				spellID = 51490,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 45,
				class = "SHAMAN",
				quality = 1,
			},

			----------------- Присты
			{ -- духовое рвение (тянулка прист)
				spellID = 73325,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 90,
				class = "PRIEST",
				quality = 1,
			},
			{ -- исчадие тьмы
				spellID = 34433,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "PRIEST",
				quality = 1,
				cast_time = 12,
			},
			{ -- масс диспел
				spellID = 32375,
				succ = "SPELL_CAST_START",
				specs = { 0 },
				CD = 15,
				class = "PRIEST",
				quality = 1,
			},
			{ -- диспел
				spellID = 527,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 8,
				class = "PRIEST",
				quality = 1,
			},
			{ -- уход в тень
				spellID = 586,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "PRIEST",
				cast_time = 10,
				quality = 1,
			},
			{ -- щит души диск
				spellID = 109964,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 60,
				class = "PRIEST",
				cast_time = 15,
				quality = 1,
			},
			{ -- объятие вампира
				spellID = 15286,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				class = "PRIEST",
				cast_time = 15,
				quality = 1,
			},

			----------------- Вары
			{ -- Героический прыжок
				spellID = 52174,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 45,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Зуботычина
				spellID = 6552,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- Отражение заклинаний
				spellID = 23920,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				class = "WARRIOR",
				cast_time = 5,
				quality = 1,
			},
			{ -- Рывок
				spellID = 100,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 20,
				class = "WARRIOR",
				quality = 1,
			},

			----------------- Роги
			{ -- исчезновение
				spellID = 1856,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маленькие хитрости
				spellID = 57934,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "ROGUE",
				cast_time = 6,
				quality = 1,
			},
			{ -- пинок
				spellID = 1766,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "ROGUE",
				quality = 1,
			},
			{ -- спринт
				spellID = 2983,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "ROGUE",
				cast_time = 8,
				quality = 1,
			},

			----------------- Маги
			{ -- маг антимагия (сало)
				spellID = 2139,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 24,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг невидимость
				spellID = 66,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 300,
				class = "MAGE",
				cast_time = 23,
				quality = 1,
			},
			{ -- маг прилив сил
				spellID = 12051,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг скачок
				spellID = 1953,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг дыхание дракона
				spellID = 31661,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 20,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг призыв пета фростом
				spellID = 31687,
				succ = "SPELL_SUMMON",
				specs = { 3 },
				CD = 60,
				class = "MAGE",
				quality = 1,
			},
			{ -- маг леденая сфера
				spellID = 84714,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 60,
				cast_time = 10,
				class = "MAGE",
				quality = 1,
			},

			----------------- Друид
			{ -- друид порыв
				spellID = 1850,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- друид тревожный рев
				spellID = 77764,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "DRUID",
				trigger = { 106898, },
				cast_time = 8,
				quality = 1,
			},
			{ -- друид снятие порчи (не рестор)
				spellID = 2782,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2, 3, },
				CD = 8,
				class = "DRUID",
				quality = 1,
			},
			{ -- друид столп солнечного света (сбитие каста)
				spellID = 78675,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "DRUID",
				cast_time = 8,
				quality = 1,
			},
			{ -- друид берсерк (котэ+мэдвед)
				spellID = 106951,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2, 3, },
				CD = 180,
				trigger = { 50334, },
				class = "DRUID",
				cast_time = 15,
				quality = 1,
			},
			{ -- друид диспел рестор
				spellID = 88423,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 4 },
				CD = 8,
				class = "DRUID",
				quality = 1,
			},

			----------------- Варлок
			{ -- варлок телепортация
				spellID = 48020,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок раскол души
				spellID = 29858,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок ритуал призыва
				spellID = 698,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},
			{ -- варлок создание источника душ
				spellID = 29893,
				succ = "SPELL_CREATE",
				specs = { 0 },
				CD = 120,
				class = "WARLOCK",
				quality = 1,
			},

			----------------- Паладин
			{ -- паладин божественная защита (-40% магии)
				spellID = 498,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				cast_time = 10,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин божественно покровительство (20% хасты хпалу)
				spellID = 31842,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 180,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин лох
				spellID = 633,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 600,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин фридом
				spellID = 1044,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				cast_time = 6,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин диспел
				spellID = 4987,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 8,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин укор (сбитие каста)
				spellID = 96231,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "PALADIN",
				quality = 1,
			},

			----------------- хантер
			{ -- хант осветилеьный выстрел
				spellID = 1543,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 20,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант отрыв
				spellID = 781,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 20,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант перенаправление
				spellID = 34477,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант приказ хозяина (фридом себе)
				spellID = 53271,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 45,
				cast_time = 4,
				class = "HUNTER",
				quality = 1,
			},

			------------------ монах
			{ -- монах диспел
				spellID = 115450,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 8,
				class = "MONK",
				quality = 1,
			},
			{ -- монах рука-копье (сбитие каста)
				spellID = 116705,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "MONK",
				quality = 1,
			},
			{ -- монах удар летящего змея
				spellID = 101545,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 25,
				class = "MONK",
				quality = 1,
			},
			{ -- монах chi wave
				spellID = 115098,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "MONK",
				quality = 1,
			},
			{ -- монах chi burst
				spellID = 123986,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "MONK",
				quality = 1,
			},

			------------------ дк
			{ -- дк антимагический панцирь
				spellID = 48707,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 45,
				cast_time = 5,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк сбитие каста
				spellID = 47528,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 15,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк хваталка
				spellID = 49576,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- дк призыв горгульи
				spellID = 49206,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 30,
				class = "DEATHKNIGHT",
				quality = 1,
			},
		}
		local type9 = {--  type == 9  пвп кулдауны на контроль
			{ -- паладин слепящий свет
				spellID = 115750,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "PALADIN",
				quality = 1,
			},
			{ -- стан прист
				spellID = 64044,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 45,
				class = "PRIEST",
				quality = 1,
			},
			{ -- сало прист
				spellID = 15487,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 45,
				class = "PRIEST",
				quality = 1,
				cast_time = 5,
			},
			{ -- Устрашающий крик (фир вара)
				spellID = 5246,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 90,
				class = "WARRIOR",
				quality = 1,
			},
			{ -- ослепление
				spellID = 2094,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 120,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маг кольцо льда
				spellID = 122,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 25,
				class = "MAGE",
				quality = 1,
			},
			{ -- друид ферал циклон
				spellID = 33786,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2, 3 },
				CD = 20,
				class = "DRUID",
				quality = 1,
			},
			{ -- дк сало
				spellID = 47476,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- паладин стан
				spellID = 853,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 60,
				class = "PALADIN",
				quality = 1,
			},
		}
		local type10 = {-- type == 10 кулдауны личные на +дамаг
			{ -- Дух дикого волка энх
				spellID = 51533,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 120,
				cast_time = 15,
				class = "SHAMAN",
				quality = 1,
			},
			{ -- Ярость берсерка
				spellID = 18499,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 30,
				class = "WARRIOR",
				cast_time = 6,
				quality = 1,
			},
			{ -- Безрассудство
				spellID = 1719,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 300,
				class = "WARRIOR",
				cast_time = 12,
				quality = 1,
			},
			{ -- Вендетта
				spellID = 79140,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 120,
				class = "ROGUE",
				cast_time = 20,
				quality = 1,
			},
			{ -- Выброс адреналина
				spellID = 13750,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 180,
				class = "ROGUE",
				cast_time = 15,
				quality = 1,
			},
			{ -- Череда убийств
				spellID = 51690,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 120,
				class = "ROGUE",
				quality = 1,
			},
			{ -- маг мощь тайной магии
				spellID = 12042,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 90,
				class = "MAGE",
				cast_time = 15,
				quality = 1,
			},
			{ -- маг стылая кровь фрост
				spellID = 12472,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 20,
				class = "MAGE",
				quality = 1,
			},
			{ -- паладин крылья
				spellID = 31884,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1, 2 },
				CD = 180,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- паладин крылья
				spellID = 31884,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 120,
				cast_time = 20,
				class = "PALADIN",
				quality = 1,
			},
			{ -- хант быстрая стрельба
				spellID = 3045,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 15,
				class = "HUNTER",
				quality = 1,
			},
			{ -- хант бм+дамаг
				spellID = 19574,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 60,
				cast_time = 10,
				class = "HUNTER",
				quality = 1,
			},
			{ -- дк Ледяной столп (+сила фросту)
				spellID = 51271,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 60,
				cast_time = 20,
				class = "DEATHKNIGHT",
				quality = 1,
			},
			{ -- шаман Перерождение
				spellID = 114049,
				succ = "SPELL_CAST_SUCCESS",
				specs = { 0 },
				CD = 180,
				cast_time = 15,
				trigger = { 114050, 114051, 114052 },
				class = "SHAMAN",
				quality = 1,
			},
		}

		local shok = { -- для отладки
			spellID = 6673, -- ID спелла
			class = "WARRIOR", -- класс, которому принадлежит спелл
			CD = 12, -- кулдаун в секундах у спела
			specs = { 0 },
			succ = "SPELL_CAST_SUCCESS", -- тип ивента, который означает удачное применение , возможен вариант массива { "SPELL_HEAL", "SPELL_AURA_APPLIED" }
			type = 1,  --[[ тип спелла:
					1 - аура на -дамаг (купол, мастер аур и тд)
					2 - аое хил (гимн пристов, транквил)
					3 - на ману (иннеры, гимн на ману, мана тайд)
					4 - личный кд (айс блок, шв, бабл, отражение)
					5 - точечный кд (пс, крылья, придание сил)
					6 - кд на +дамаг (варовский -армор, бл)
					7 - возрождения (друид, шаман, дк, лок)
					8 - прочие кд
					9 - кулдауны на контроль (приоритет на пвп)
					10 - кулдауны личные на +дамаг
				]]
			trigger = { 6673, }, -- дополнительные ид с которых триггерится ивент
			cast_time = 0, -- время действия спелла
			quality = 3, -- качество спелла при сортировке 1/nil - плохое 2 - хорошее 3 - лучшее
			charges = 20, -- количество зарядов спелла
		}

		local bad_spells = 0;
		local function formArray(arr, t)
		    for _, i in next, arr do
			    if (select(1, GetSpellInfo(i.spellID)) ~= nil) then
				    i.type = t
					table.insert(spells, i)
				else
					bad_spells = bad_spells + 1
					HCoold:Printf("   bad spell id = %d", i.spellID)
				end
			end
		end

		formArray(type1, 1)
		formArray(type2, 2)
		formArray(type3, 3)
		formArray(type4, 4)
		formArray(type5, 5)
		formArray(type6, 6)
		formArray(type7, 7)
		formArray(type8, 8)
		formArray(type9, 9)
		formArray(type10, 10)
		HCoold:Printf("Found %d old spells in common spells", bad_spells)
		HCoold.config.types_amount = 10

		if HCoold.debug then table.insert(spells,shok) end
	end

	do -- generate list_talents
        local list_warrior = {
            [46968] = { -- Shockwave http://www.wowhead.com/spell=46968
                spellID = 46968,
                class = "WARRIOR",
                CD = 40,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 4,
                quality = 1,
            },
            [107570] = { -- Storm Bolt http://www.wowhead.com/spell=107570
                spellID = 107570,
                class = "WARRIOR",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 4,
                quality = 1,
            },
            [202168] = { -- Impending Victory http://www.wowhead.com/spell=202168
                spellID = 202168,
                class = "WARRIOR",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [107574] = { -- Avatar http://www.wowhead.com/spell=107574
                spellID = 107574,
                class = "WARRIOR",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 10,
                -- trigger = {},
                cast_time = 20,
                quality = 1,
            },
            [12292] = { -- Bloodbath http://www.wowhead.com/spell=12292
                spellID = 12292,
                class = "WARRIOR",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 10,
                -- trigger = {},
                cast_time = 8,
                quality = 1,
            },
            [46924] = { -- Bladestorm http://www.wowhead.com/spell=46924
                spellID = 46924,
                class = "WARRIOR",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 10,
                -- trigger = {},
                cast_time = 6,
                quality = 1,
            },
            [118000] = { -- Dragon Roar http://www.wowhead.com/spell=118000
                spellID = 118000,
                class = "WARRIOR",
                CD = 25,
                succ = "SPELL_CAST_SUCCESS",
                type = 10,
                -- trigger = {},
                cast_time = 6,
                quality = 1,
            },
            [152277] = { -- Ravager http://www.wowhead.com/spell=152277
                spellID = 152277,
                class = "WARRIOR",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 10,
                -- trigger = {},
                cast_time = 7,
                quality = 1,
            },
            [228920] = { -- Ravager http://www.wowhead.com/spell=228920
                spellID = 228920,
                class = "WARRIOR",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                -- trigger = {},
                cast_time = 7,
                quality = 1,
            },
        }
        local list_paladin = {
            [223306] = { -- Bestow Faith http://www.wowhead.com/spell=223306
                spellID = 223306,
                class = "PALADIN",
                CD = 12,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 5,
                quality = 1,
            },
            [114158] = { -- Light's Hammer http://www.wowhead.com/spell=114158
                spellID = 114158,
                class = "PALADIN",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 2,
                -- trigger = {},
                cast_time = 14,
                quality = 1,
            },
            [213757] = { -- Execution Sentence http://www.wowhead.com/spell=213757
                spellID = 213757,
                class = "PALADIN",
                CD = 20,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 7,
                quality = 1,
            },
            [204035] = { -- Bastion of Light http://www.wowhead.com/spell=204035
                spellID = 204035,
                class = "PALADIN",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                quality = 1,
            },
            [115750] = { -- Blinding Light http://www.wowhead.com/spell=115750
                spellID = 115750,
                class = "PALADIN",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 6,
                quality = 1,
            },
            [204018] = { -- Blessing of Spellwarding http://www.wowhead.com/spell=204018
                spellID = 204018,
                class = "PALADIN",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 5,
                -- trigger = {},
                cast_time = 10,
                quality = 2,
            },
            [204013] = { -- Blessing of Salvation http://www.wowhead.com/spell=204013
                spellID = 204013,
                class = "PALADIN",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 5,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [105809] = { -- Holy Avenger http://www.wowhead.com/spell=105809
                spellID = 105809,
                class = "PALADIN",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 6,
                -- trigger = {},
                cast_time = 20,
                quality = 1,
            },
            [205191] = { -- Eye for an Eye http://www.wowhead.com/spell=205191
                spellID = 205191,
                class = "PALADIN",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                turn_on = true,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [210191] = { -- Word of Glory http://www.wowhead.com/spell=210191
                spellID = 210191,
                class = "PALADIN",
                CD = 1,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
                charges = 2,
            },
            [204150] = { -- Aegis of Light http://www.wowhead.com/spell=204150
                spellID = 204150,
                class = "PALADIN",
                CD = 300,
                succ = "SPELL_CAST_SUCCESS",
                type = 1,
                turn_on = true,
                -- trigger = {},
                cast_time = 6,
                quality = 3,
            },
            [210220] = { -- Holy Wrath http://www.wowhead.com/spell=210220
                spellID = 210220,
                class = "PALADIN",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
        }
        local list_hunter = {
            [201078] = { -- Snake Hunter http://www.wowhead.com/spell=201078
                spellID = 201078,
                class = "HUNTER",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [212431] = { -- Explosive Shot http://www.wowhead.com/spell=212431
                spellID = 212431,
                class = "HUNTER",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 4,
                quality = 1,
            },
            [194277] = { -- Caltrops http://www.wowhead.com/spell=194277
                spellID = 194277,
                class = "HUNTER",
                CD = 15,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 6,
                quality = 1,
            },
            [191241] = { -- Sticky Bomb http://www.wowhead.com/spell=191241
                spellID = 191241,
                class = "HUNTER",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 3,
                quality = 1,
            },
            [109248] = { -- Binding Shot http://www.wowhead.com/spell=109248
                spellID = 109248,
                class = "HUNTER",
                CD = 45,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 5,
                quality = 1,
            },
            [19577] = { -- Intimidation http://www.wowhead.com/spell=19577
                spellID = 19577,
                class = "HUNTER",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 5,
                quality = 1,
            },
            [199483] = { -- Camouflage http://www.wowhead.com/spell=199483
                spellID = 199483,
                class = "HUNTER",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 60,
                quality = 1,
            },
            [201430] = { -- Stampede http://www.wowhead.com/spell=201430
                spellID = 201430,
                class = "HUNTER",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 12,
                quality = 1,
            },
        }
        local list_rogue = {
            [195457] = { -- Grappling Hook http://www.wowhead.com/spell=195457
                spellID = 195457,
                class = "ROGUE",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [199743] = { -- Parley http://www.wowhead.com/spell=199743
                spellID = 199743,
                class = "ROGUE",
                CD = 20,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 300,
                quality = 1,
            },
            [185767] = { -- Cannonball Barrage http://www.wowhead.com/spell=185767
                spellID = 185767,
                class = "ROGUE",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 1,
                quality = 1,
            },
            [51690] = { -- Killing Spree http://www.wowhead.com/spell=51690
                spellID = 51690,
                class = "ROGUE",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 3,
                quality = 1,
            },
        }
        local list_priest = {
            [121536] = { -- Angelic Feather http://www.wowhead.com/spell=121536
                spellID = 121536,
                class = "PRIEST",
                CD = 20,
                charges = 3,
                succ = "SPELL_CAST_SUCCESS",
                type = 81,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [19236] = { -- Desperate Prayer http://www.wowhead.com/spell=19236
                spellID = 19236,
                class = "PRIEST",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [204263] = { -- Shining Force http://www.wowhead.com/spell=204263
                spellID = 204263,
                class = "PRIEST",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 3,
                quality = 1,
            },
            [205369] = { -- Mind Bomb http://www.wowhead.com/spell=205369
                spellID = 205369,
                class = "PRIEST",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 2,
                quality = 1,
            },
            [123040] = { -- Mindbender http://www.wowhead.com/spell=123040
                spellID = 123040,
                class = "PRIEST",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 12,
                quality = 1,
            },
            [64901] = { -- Symbol of Hope http://www.wowhead.com/spell=64901
                spellID = 64901,
                class = "PRIEST",
                CD = 360,
                succ = "SPELL_CAST_SUCCESS",
                type = 3,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [10060] = { -- Power Infusion http://www.wowhead.com/spell=10060
                spellID = 10060,
                class = "PRIEST",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                -- trigger = {},
                cast_time = 20,
                quality = 1,
            },
            [120517] = { -- Halo http://www.wowhead.com/spell=120517
                spellID = 120517,
                class = "PRIEST",
                CD = 40,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 3,
                quality = 1,
            },
            [200174] = { -- Mindbender http://www.wowhead.com/spell=200174
                spellID = 200174,
                class = "PRIEST",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 15,
                quality = 1,
            },
            [200183] = { -- Apotheosis http://www.wowhead.com/spell=200183
                spellID = 200183,
                class = "PRIEST",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 30,
                quality = 1,
            },
            [193223] = { -- Surrender to Madness http://www.wowhead.com/spell=193223
                spellID = 193223,
                class = "PRIEST",
                CD = 600,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 180,
                quality = 1,
            },
        }
        local list_deathknight = {
            [206931] = { -- Blooddrinker http://www.wowhead.com/spell=206931
                spellID = 206931,
                class = "DEATHKNIGHT",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 3,
                quality = 1,
            },
            [207167] = { -- Blinding Sleet http://www.wowhead.com/spell=207167
                spellID = 207167,
                class = "DEATHKNIGHT",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 4,
                quality = 1,
            },
            [108194] = { -- Asphyxiate http://www.wowhead.com/spell=108194
                spellID = 108194,
                class = "DEATHKNIGHT",
                CD = 45,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 5,
                quality = 2,
            },
            [219809] = { -- Tombstone http://www.wowhead.com/spell=219809
                spellID = 219809,
                class = "DEATHKNIGHT",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                turn_on = true,
                -- trigger = {},
                cast_time = 8,
                quality = 1,
            },
            [207319] = { -- Corpse Shield http://www.wowhead.com/spell=207319
                spellID = 207319,
                class = "DEATHKNIGHT",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                turn_on = true,
                type = 4,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [194844] = { -- Bonestorm http://www.wowhead.com/spell=194844
                spellID = 194844,
                class = "DEATHKNIGHT",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [207256] = { -- Obliteration http://www.wowhead.com/spell=207256
                spellID = 207256,
                class = "DEATHKNIGHT",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 8,
                quality = 1,
            },
            [207349] = { -- Dark Arbiter http://www.wowhead.com/spell=207349
                spellID = 207349,
                class = "DEATHKNIGHT",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 15,
                quality = 1,
            },
            [206977] = { -- Blood Mirror http://www.wowhead.com/spell=206977
                spellID = 206977,
                class = "DEATHKNIGHT",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
        }
        local list_shaman = {
            [108281] = { -- Ancestral Guidance http://www.wowhead.com/spell=108281
                spellID = 108281,
                class = "SHAMAN",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 2,
                turn_on = true,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [192077] = { -- Wind Rush Totem http://www.wowhead.com/spell=192077
                spellID = 192077,
                class = "SHAMAN",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 15,
                quality = 1,
            },
            [192058] = { -- Lightning Surge Totem http://www.wowhead.com/spell=192058
                spellID = 192058,
                class = "SHAMAN",
                CD = 45,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 4,
                quality = 1,
            },
            [51485] = { -- Earthgrab Totem http://www.wowhead.com/spell=51485
                spellID = 51485,
                class = "SHAMAN",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 20,
                quality = 1,
            },
            [196932] = { -- Voodoo Totem http://www.wowhead.com/spell=196932
                spellID = 196932,
                class = "SHAMAN",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [117014] = { -- Elemental Blast http://www.wowhead.com/spell=117014
                spellID = 117014,
                class = "SHAMAN",
                CD = 12,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [207399] = { -- Ancestral Protection Totem http://www.wowhead.com/spell=207399
                spellID = 207399,
                class = "SHAMAN",
                CD = 300,
                turn_on = true,
                succ = "SPELL_CAST_SUCCESS",
                type = 7,
                -- trigger = {},
                cast_time = 30,
                quality = 1,
            },
            [198838] = { -- Earthen Shield Totem http://www.wowhead.com/spell=198838
                spellID = 198838,
                class = "SHAMAN",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 1,--turn on
                -- trigger = {},
                cast_time = 15,
                quality = 1,
            },
            [16166] = { -- Elemental Mastery http://www.wowhead.com/spell=16166
                spellID = 16166,
                class = "SHAMAN",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                -- trigger = {},
                cast_time = 20,
                quality = 1,
            },
            [192249] = { -- Storm Elemental http://www.wowhead.com/spell=192249
                spellID = 192249,
                class = "SHAMAN",
                CD = 300,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 60,
                quality = 1,
            },
            [157153] = { -- Cloudburst Totem http://www.wowhead.com/spell=157153
                spellID = 157153,
                class = "SHAMAN",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 15,
                quality = 1,
            },
            [114050] = { -- Ascendance http://www.wowhead.com/spell=114050
                spellID = 114050,
                class = "SHAMAN",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                trigger = { 114051, 114052, },
                cast_time = 15,
                quality = 1,
            },
        }
        local list_mage = {
            [205021] = { -- Ray of Frost http://www.wowhead.com/spell=205021
                spellID = 205021,
                class = "MAGE",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 10,
                quality = 1,
            },
            [205025] = { -- Presence of Mind http://www.wowhead.com/spell=205025
                spellID = 205025,
                class = "MAGE",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [212653] = { -- Shimmer http://www.wowhead.com/spell=212653
                spellID = 212653,
                class = "MAGE",
                CD = 15,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                charges = 2,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [55342] = { -- Mirror Image http://www.wowhead.com/spell=55342
                spellID = 55342,
                class = "MAGE",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 40,
                quality = 1,
            },
            [157997] = { -- Ice Nova http://www.wowhead.com/spell=157997
                spellID = 157997,
                class = "MAGE",
                CD = 25,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 2,
                quality = 1,
            },
            [113724] = { -- Ring of Frost http://www.wowhead.com/spell=113724
                spellID = 113724,
                class = "MAGE",
                CD = 45,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 10,
                quality = 2,
            },
        }
        local list_warlock = {
            [6789] = { -- Mortal Coil http://www.wowhead.com/spell=6789
                spellID = 6789,
                class = "WARLOCK",
                CD = 45,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 3,
                quality = 1,
            },
            [30283] = { -- Shadowfury http://www.wowhead.com/spell=30283
                spellID = 30283,
                class = "WARLOCK",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 4,
                quality = 2,
            },
            [5484] = { -- Howl of Terror http://www.wowhead.com/spell=5484
                spellID = 5484,
                class = "WARLOCK",
                CD = 40,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 20,
                quality = 2,
            },
            [108416] = { -- Dark Pact http://www.wowhead.com/spell=108416
                spellID = 108416,
                class = "WARLOCK",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 20,
                quality = 1,
            },
            [205179] = { -- Phantom Singularity http://www.wowhead.com/spell=205179
                spellID = 205179,
                class = "WARLOCK",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 16,
                quality = 1,
            },
        }
        local list_monk = {
            [116841] = { -- Tiger's Lust http://www.wowhead.com/spell=116841
                spellID = 116841,
                class = "MONK",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 5,
                -- trigger = {},
                cast_time = 6,
                quality = 1,
            },
            [116844] = { -- Ring of Peace http://www.wowhead.com/spell=116844
                spellID = 116844,
                class = "MONK",
                CD = 45,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 8,
                quality = 1,
            },
            [198898] = { -- Song of Chi-Ji http://www.wowhead.com/spell=198898
                spellID = 198898,
                class = "MONK",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 5,
                quality = 1,
            },
            [119381] = { -- Leg Sweep http://www.wowhead.com/spell=119381
                spellID = 119381,
                class = "MONK",
                CD = 45,
                succ = "SPELL_CAST_SUCCESS",
                type = 6,
                -- trigger = {},
                cast_time = 5,
                quality = 2,
            },
            [122783] = { -- Diffuse Magic http://www.wowhead.com/spell=122783
                spellID = 122783,
                class = "MONK",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                turn_on = true,
                -- trigger = {},
                cast_time = 6,
                quality = 2,
            },
            [122278] = { -- Dampen Harm http://www.wowhead.com/spell=122278
                spellID = 122278,
                class = "MONK",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                turn_on = true,
                -- trigger = {},
                cast_time = 45,
                quality = 1,
            },
            [123904] = { -- Invoke Xuen, the White Tiger http://www.wowhead.com/spell=123904
                spellID = 123904,
                class = "MONK",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 45,
                quality = 1,
            },
            [132578] = { -- Invoke Niuzao, the Black Ox http://www.wowhead.com/spell=132578
                spellID = 132578,
                class = "MONK",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 45,
                quality = 1,
            },
            [198664] = { -- Invoke Chi-Ji, the Red Crane http://www.wowhead.com/spell=198664
                spellID = 198664,
                class = "MONK",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 45,
                quality = 1,
            },
            [152173] = { -- Serenity http://www.wowhead.com/spell=152173
                spellID = 152173,
                class = "MONK",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 8,
                quality = 1,
            },
        }
        local list_druid = {
            [108238] = { -- Renewal http://www.wowhead.com/spell=108238
                spellID = 108238,
                class = "DRUID",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 0,
                quality = 1,
            },
            [102280] = { -- Displacer Beast http://www.wowhead.com/spell=102280
                spellID = 102280,
                class = "DRUID",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 4,
                quality = 1,
            },
            [5211] = { -- Mighty Bash http://www.wowhead.com/spell=5211
                spellID = 5211,
                class = "DRUID",
                CD = 50,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 5,
                quality = 1,
            },
            [102359] = { -- Mass Entanglement http://www.wowhead.com/spell=102359
                spellID = 102359,
                class = "DRUID",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 20,
                quality = 1,
            },
            [132469] = { -- Typhoon http://www.wowhead.com/spell=132469
                spellID = 132469,
                class = "DRUID",
                CD = 30,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 6,
                quality = 1,
            },
            [102560] = { -- Incarnation: Chosen of Elune http://www.wowhead.com/spell=102560
                spellID = 102560,
                class = "DRUID",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 30,
                quality = 1,
            },
            [102543] = { -- Incarnation: King of the Jungle http://www.wowhead.com/spell=102543
                spellID = 102543,
                class = "DRUID",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 30,
                quality = 1,
            },
            [102558] = { -- Incarnation: Guardian of Ursoc http://www.wowhead.com/spell=102558
                spellID = 102558,
                class = "DRUID",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 30,
                quality = 1,
            },
            [33891] = { -- Incarnation: Tree of Life http://www.wowhead.com/spell=33891
                spellID = 33891,
                class = "DRUID",
                CD = 180,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 30,
                quality = 1,
            },
            [204066] = { -- Lunar Beam http://www.wowhead.com/spell=204066
                spellID = 204066,
                class = "DRUID",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 8,
                quality = 1,
            },
        }
        local list_demonhunter = {
            [196555] = { -- Netherwalk http://www.wowhead.com/spell=196555
                spellID = 196555,
                class = "DEMONHUNTER",
                CD = 90,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 5,
                quality = 1,
            },
            [211881] = { -- Fel Eruption http://www.wowhead.com/spell=211881
                spellID = 211881,
                class = "DEMONHUNTER",
                CD = 35,
                succ = "SPELL_CAST_SUCCESS",
                type = 9,
                -- trigger = {},
                cast_time = 2,
                quality = 1,
            },
            [206491] = { -- Nemesis http://www.wowhead.com/spell=206491
                spellID = 206491,
                class = "DEMONHUNTER",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 8,
                -- trigger = {},
                cast_time = 60,
                quality = 1,
            },
            [212084] = { -- Fel Devastation http://www.wowhead.com/spell=212084
                spellID = 212084,
                class = "DEMONHUNTER",
                CD = 60,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                -- trigger = {},
                cast_time = 2,
                quality = 1,
            },
            [211048] = { -- Chaos Blades http://www.wowhead.com/spell=211048
                spellID = 211048,
                class = "DEMONHUNTER",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 1,
                -- trigger = {},
                cast_time = 12,
                quality = 8,
            },
            [207810] = { -- Nether Bond http://www.wowhead.com/spell=207810
                spellID = 207810,
                class = "DEMONHUNTER",
                CD = 120,
                succ = "SPELL_CAST_SUCCESS",
                type = 5,--turn on
                -- trigger = {},
                cast_time = 15,
                quality = 1,
            },
            [227225] = { -- Soul Barrier http://www.wowhead.com/spell=227225
                spellID = 227225,
                class = "DEMONHUNTER",
                CD = 20,
                succ = "SPELL_CAST_SUCCESS",
                type = 4,
                -- trigger = {},
                cast_time = 8,
                quality = 1,
            },
        }

		local bad_spells = 0;
		local function formArray(arr)
		    for k, i in next, arr do
			    if (select(1, GetSpellInfo(i.spellID)) ~= nil) then
				    i.talent = true
					list_talents[k] = i
				else
					bad_spells = bad_spells + 1
					HCoold:Printf("   bad spell id = %d", i.spellID)
				end
			end
		end

		-- for i = 55694, 55794, 1 do if (GetSpellLink(i) ~= nil) then HCoold:Printf("Spell %d %s", i, GetSpellLink(i)) end end

        formArray(list_warrior)
        formArray(list_paladin)
        formArray(list_hunter)
        formArray(list_rogue)
        formArray(list_priest)
        formArray(list_deathknight)
        formArray(list_shaman)
        formArray(list_mage)
        formArray(list_warlock)
        formArray(list_monk)
        formArray(list_druid)
        formArray(list_demonhunter)

		HCoold:Printf("Found %d old spells in talents", bad_spells)
	end

	do -- generate spec_spells
        table.insert(spec_spells, { -- WARRIOR 1 Arms 2 Fury 3 Protection
            class = "WARRIOR",
            specs = {
                [1] = { -- Arms
                    { id = 12294, }, -- Mortal Strike http://www.wowhead.com/spell=12294
                    { id = 227847, }, -- Bladestorm http://www.wowhead.com/spell=227847
                    { id = 845, }, -- Cleave http://www.wowhead.com/spell=845
                    { id = 167105, }, -- Colossus Smash http://www.wowhead.com/spell=167105
                    { id = 118038, }, -- Die by the Sword http://www.wowhead.com/spell=118038
                    { id = 163201, }, -- Execute http://www.wowhead.com/spell=163201
                    { id = 1464, }, -- Slam http://www.wowhead.com/spell=1464
                    { id = 1680, }, -- Whirlwind http://www.wowhead.com/spell=1680
                    { id = 1715, }, -- Hamstring http://www.wowhead.com/spell=1715
                },
                [2] = { -- Fury
                    { id = 12323, }, -- Piercing Howl http://www.wowhead.com/spell=12323
                    { id = 184367, }, -- Rampage http://www.wowhead.com/spell=184367
                    { id = 184364, }, -- Enraged Regeneration http://www.wowhead.com/spell=184364
                    { id = 5308, }, -- Execute http://www.wowhead.com/spell=5308
                    { id = 85288, }, -- Raging Blow http://www.wowhead.com/spell=85288
                    { id = 23881, }, -- Bloodthirst http://www.wowhead.com/spell=23881
                    { id = 100130, }, -- Furious Slash http://www.wowhead.com/spell=100130
                    { id = 190411, }, -- Whirlwind http://www.wowhead.com/spell=190411
                },
                [3] = { -- Protection
                    { id = 6343, }, -- Thunder Clap http://www.wowhead.com/spell=6343
                    { id = 6572, }, -- Revenge http://www.wowhead.com/spell=6572
                    { id = 2565, }, -- Shield Block http://www.wowhead.com/spell=2565
                    { id = 12975, }, -- Last Stand http://www.wowhead.com/spell=12975
                    { id = 871, }, -- Shield Wall http://www.wowhead.com/spell=871
                    { id = 1160, }, -- Demoralizing Shout http://www.wowhead.com/spell=1160
                    { id = 23920, }, -- Spell Reflection http://www.wowhead.com/spell=23920
                    { id = 23922, }, -- Shield Slam http://www.wowhead.com/spell=23922
                    { id = 198304, }, -- Intercept http://www.wowhead.com/spell=198304
                    { id = 204488, }, -- Focused Rage http://www.wowhead.com/spell=204488
                    { id = 20243, }, -- Devastate http://www.wowhead.com/spell=20243
                    { id = 157494, }, -- Improved Defensive Stance http://www.wowhead.com/spell=157494
                    { id = 157497, }, -- Improved Block http://www.wowhead.com/spell=157497
                    { id = 190456, }, -- Ignore Pain http://www.wowhead.com/spell=190456
                },
            },
        })
        table.insert(spec_spells, { -- PALADIN 1 Holy 2 Protection 3 Retribution
            class = "PALADIN",
            specs = {
                [1] = { -- Holy
                    { id = 53563, }, -- Beacon of Light http://www.wowhead.com/spell=53563
                    { id = 82326, }, -- Holy Light http://www.wowhead.com/spell=82326
                    { id = 4987, }, -- Cleanse http://www.wowhead.com/spell=4987
                    { id = 31821, }, -- Aura Mastery http://www.wowhead.com/spell=31821
                    { id = 212056, }, -- Absolution http://www.wowhead.com/spell=212056
                    { id = 31842, }, -- Avenging Wrath http://www.wowhead.com/spell=31842
                    { id = 85222, }, -- Light of Dawn http://www.wowhead.com/spell=85222
                    { id = 183998, }, -- Light of the Martyr http://www.wowhead.com/spell=183998
                    { id = 20473, }, -- Holy Shock http://www.wowhead.com/spell=20473
                },
                [2] = { -- Protection
                    { id = 190784, }, -- Divine Steed http://www.wowhead.com/spell=190784
                    { id = 53595, }, -- Hammer of the Righteous http://www.wowhead.com/spell=53595
                    { id = 53600, }, -- Shield of the Righteous http://www.wowhead.com/spell=53600
                    { id = 86659, }, -- Guardian of Ancient Kings http://www.wowhead.com/spell=86659
                    { id = 31850, }, -- Ardent Defender http://www.wowhead.com/spell=31850
                    { id = 31935, }, -- Avenger's Shield http://www.wowhead.com/spell=31935
                    { id = 184092, }, -- Light of the Protector http://www.wowhead.com/spell=184092
                },
                [3] = { -- Retribution
                    { id = 53385, }, -- Divine Storm http://www.wowhead.com/spell=53385
                    { id = 184575, }, -- Blade of Justice http://www.wowhead.com/spell=184575
                    { id = 184662, }, -- Shield of Vengeance http://www.wowhead.com/spell=184662
                    { id = 203528, }, -- Greater Blessing of Might http://www.wowhead.com/spell=203528
                    { id = 203539, }, -- Greater Blessing of Wisdom http://www.wowhead.com/spell=203539
                    { id = 203538, }, -- Greater Blessing of Kings http://www.wowhead.com/spell=203538
                    { id = 183218, }, -- Hand of Hindrance http://www.wowhead.com/spell=183218
                    { id = 85256, }, -- Templar's Verdict http://www.wowhead.com/spell=85256
                },
            },
        })
        table.insert(spec_spells, { -- HUNTER 1 Beast Mastery 2 Marksmanship 3 Survival
            class = "HUNTER",
            specs = {
                [1] = { -- Beast Mastery
                    { id = 193455, }, -- Cobra Shot http://www.wowhead.com/spell=193455
                    { id = 193530, }, -- Aspect of the Wild http://www.wowhead.com/spell=193530
                    { id = 19574, }, -- Bestial Wrath http://www.wowhead.com/spell=19574
                    { id = 34026, }, -- Kill Command http://www.wowhead.com/spell=34026
                    { id = 120679, }, -- Dire Beast http://www.wowhead.com/spell=120679
                },
                [2] = { -- Marksmanship
                    { id = 186387, }, -- Bursting Shot http://www.wowhead.com/spell=186387
                    { id = 157726, }, -- Improved Focus http://www.wowhead.com/spell=157726
                    { id = 19434, }, -- Aimed Shot http://www.wowhead.com/spell=19434
                    { id = 193526, }, -- Trueshot http://www.wowhead.com/spell=193526
                    { id = 185358, }, -- Arcane Shot http://www.wowhead.com/spell=185358
                    { id = 185901, }, -- Marked Shot http://www.wowhead.com/spell=185901
                    { id = 194291, }, -- Exhilaration http://www.wowhead.com/spell=194291
                },
                [3] = { -- Survival
                    { id = 202800, }, -- Flanking Strike http://www.wowhead.com/spell=202800
                    { id = 190925, }, -- Harpoon http://www.wowhead.com/spell=190925
                    { id = 190928, }, -- Mongoose Bite http://www.wowhead.com/spell=190928
                    { id = 193265, }, -- Hatchet Toss http://www.wowhead.com/spell=193265
                    { id = 191433, }, -- Explosive Trap http://www.wowhead.com/spell=191433
                    { id = 195645, }, -- Wing Clip http://www.wowhead.com/spell=195645
                    { id = 187650, }, -- Freezing Trap http://www.wowhead.com/spell=187650
                    { id = 187698, }, -- Tar Trap http://www.wowhead.com/spell=187698
                    { id = 187707, }, -- Muzzle http://www.wowhead.com/spell=187707
                    { id = 187708, }, -- Carve http://www.wowhead.com/spell=187708
                    { id = 185855, }, -- Lacerate http://www.wowhead.com/spell=185855
                    { id = 186270, }, -- Raptor Strike http://www.wowhead.com/spell=186270
                    { id = 186289, }, -- Aspect of the Eagle http://www.wowhead.com/spell=186289
                },
            },
        })
        table.insert(spec_spells, { -- ROGUE 1 Assassination 2 Outlaw 3 Subtlety
            class = "ROGUE",
            specs = {
                [1] = { -- Assassination
                    { id = 8679, }, -- Wound Poison http://www.wowhead.com/spell=8679
                    { id = 51723, }, -- Fan of Knives http://www.wowhead.com/spell=51723
                    { id = 703, }, -- Garrote http://www.wowhead.com/spell=703
                    { id = 2823, }, -- Deadly Poison http://www.wowhead.com/spell=2823
                    { id = 185565, }, -- Poisoned Knife http://www.wowhead.com/spell=185565
                    { id = 79140, }, -- Vendetta http://www.wowhead.com/spell=79140
                    { id = 1329, }, -- Mutilate http://www.wowhead.com/spell=1329
                    { id = 3408, }, -- Crippling Poison http://www.wowhead.com/spell=3408
                    { id = 32645, }, -- Envenom http://www.wowhead.com/spell=32645
                    { id = 1943, }, -- Rupture http://www.wowhead.com/spell=1943
                },
                [2] = { -- Outlaw
                    { id = 2098, }, -- Run Through http://www.wowhead.com/spell=2098
                    { id = 8676, }, -- Ambush http://www.wowhead.com/spell=8676
                    { id = 193315, }, -- Saber Slash http://www.wowhead.com/spell=193315
                    { id = 193316, }, -- Roll the Bones http://www.wowhead.com/spell=193316
                    { id = 199736, }, -- Find Treasure http://www.wowhead.com/spell=199736
                    { id = 199740, }, -- Bribe http://www.wowhead.com/spell=199740
                    { id = 199754, }, -- Riposte http://www.wowhead.com/spell=199754
                    { id = 199804, }, -- Between the Eyes http://www.wowhead.com/spell=199804
                    { id = 185763, }, -- Pistol Shot http://www.wowhead.com/spell=185763
                    { id = 13750, }, -- Adrenaline Rush http://www.wowhead.com/spell=13750
                    { id = 13877, }, -- Blade Flurry http://www.wowhead.com/spell=13877
                    { id = 1776, }, -- Gouge http://www.wowhead.com/spell=1776
                },
                [3] = { -- Subtlety
                    { id = 157704, }, -- Enhanced Stealth http://www.wowhead.com/spell=157704
                    { id = 53, }, -- Backstab http://www.wowhead.com/spell=53
                    { id = 196819, }, -- Eviscerate http://www.wowhead.com/spell=196819
                    { id = 121471, }, -- Shadow Blades http://www.wowhead.com/spell=121471
                    { id = 195452, }, -- Nightblade http://www.wowhead.com/spell=195452
                    { id = 185313, }, -- Shadow Dance http://www.wowhead.com/spell=185313
                    { id = 185438, }, -- Shadowstrike http://www.wowhead.com/spell=185438
                    { id = 197835, }, -- Shuriken Storm http://www.wowhead.com/spell=197835
                    { id = 212283, }, -- Symbols of Death http://www.wowhead.com/spell=212283
                    { id = 114014, }, -- Shuriken Toss http://www.wowhead.com/spell=114014
                    { id = 157666, }, -- Enhanced Vanish http://www.wowhead.com/spell=157666
                    { id = 157671, }, -- Empowered Fan of Knives http://www.wowhead.com/spell=157671
                },
            },
        })
        table.insert(spec_spells, { -- PRIEST 1 Discipline 2 Holy 3 Shadow
            class = "PRIEST",
            specs = {
                [1] = { -- Discipline
                    { id = 200829, }, -- Plea http://www.wowhead.com/spell=200829
                    { id = 47536, }, -- Rapture http://www.wowhead.com/spell=47536
                    { id = 47540, }, -- Penance http://www.wowhead.com/spell=47540
                    { id = 33206, }, -- Pain Suppression http://www.wowhead.com/spell=33206
                    { id = 62618, }, -- Power Word: Barrier http://www.wowhead.com/spell=62618
                    { id = 194509, }, -- Power Word: Radiance http://www.wowhead.com/spell=194509
                },
                [2] = { -- Holy
                    { id = 2050, }, -- Holy Word: Serenity http://www.wowhead.com/spell=2050
                    { id = 2060, }, -- Heal http://www.wowhead.com/spell=2060
                    { id = 2061, }, -- Flash Heal http://www.wowhead.com/spell=2061
                    { id = 34861, }, -- Holy Word: Sanctify http://www.wowhead.com/spell=34861
                    { id = 139, }, -- Renew http://www.wowhead.com/spell=139
                    { id = 33076, }, -- Prayer of Mending http://www.wowhead.com/spell=33076
                    { id = 88625, }, -- Holy Word: Chastise http://www.wowhead.com/spell=88625
                    { id = 14914, }, -- Holy Fire http://www.wowhead.com/spell=14914
                    { id = 596, }, -- Prayer of Healing http://www.wowhead.com/spell=596
                    { id = 47788, }, -- Guardian Spirit http://www.wowhead.com/spell=47788
                    { id = 132157, }, -- Holy Nova http://www.wowhead.com/spell=132157
                    { id = 64843, }, -- Divine Hymn http://www.wowhead.com/spell=64843
                },
                [3] = { -- Shadow
                    { id = 34914, }, -- Vampiric Touch http://www.wowhead.com/spell=34914
                    { id = 47585, }, -- Dispersion http://www.wowhead.com/spell=47585
                    { id = 213634, }, -- Purify Disease http://www.wowhead.com/spell=213634
                    { id = 228260, }, -- Void Eruption http://www.wowhead.com/spell=228260
                    { id = 48045, }, -- Mind Sear http://www.wowhead.com/spell=48045
                    { id = 15286, }, -- Vampiric Embrace http://www.wowhead.com/spell=15286
                    { id = 15407, }, -- Mind Flay http://www.wowhead.com/spell=15407
                    { id = 15487, }, -- Silence http://www.wowhead.com/spell=15487
                    { id = 32379, }, -- Shadow Word: Death http://www.wowhead.com/spell=32379
                    { id = 194248, }, -- Insanity Visual Controller http://www.wowhead.com/spell=194248
                    { id = 8092, }, -- Mind Blast http://www.wowhead.com/spell=8092
                },
            },
        })
        table.insert(spec_spells, { -- DEATHKNIGHT 1 Blood 2 Frost 3 Unholy
            class = "DEATHKNIGHT",
            specs = {
                [1] = { -- Blood
                    { id = 206930, }, -- Heart Strike http://www.wowhead.com/spell=206930
                    { id = 221562, }, -- Asphyxiate http://www.wowhead.com/spell=221562
                    { id = 195182, }, -- Marrowrend http://www.wowhead.com/spell=195182
                    { id = 195292, }, -- Death's Caress http://www.wowhead.com/spell=195292
                    { id = 195740, }, -- Blood Plague http://www.wowhead.com/spell=195740
                    { id = 50842, }, -- Blood Boil http://www.wowhead.com/spell=50842
                    { id = 108199, }, -- Gorefiend's Grasp http://www.wowhead.com/spell=108199
                    { id = 49028, }, -- Dancing Rune Weapon http://www.wowhead.com/spell=49028
                    { id = 55233, }, -- Vampiric Blood http://www.wowhead.com/spell=55233
                },
                [2] = { -- Frost
                    { id = 49184, }, -- Howling Blast http://www.wowhead.com/spell=49184
                    { id = 51271, }, -- Pillar of Frost http://www.wowhead.com/spell=51271
                    { id = 196770, }, -- Remorseless Winter http://www.wowhead.com/spell=196770
                    { id = 47568, }, -- Empower Rune Weapon http://www.wowhead.com/spell=47568
                    { id = 49020, }, -- Obliterate http://www.wowhead.com/spell=49020
                    { id = 49143, }, -- Frost Strike http://www.wowhead.com/spell=49143
                },
                [3] = { -- Unholy
                    { id = 49206, }, -- Summon Gargoyle http://www.wowhead.com/spell=49206
                    { id = 63560, }, -- Dark Transformation http://www.wowhead.com/spell=63560
                    { id = 47541, }, -- Death Coil http://www.wowhead.com/spell=47541
                    { id = 46584, }, -- Raise Dead http://www.wowhead.com/spell=46584
                    { id = 42650, }, -- Army of the Dead http://www.wowhead.com/spell=42650
                    { id = 77575, }, -- Outbreak http://www.wowhead.com/spell=77575
                    { id = 55090, }, -- Scourge Strike http://www.wowhead.com/spell=55090
                    { id = 85948, }, -- Festering Strike http://www.wowhead.com/spell=85948
                },
            },
        })
        table.insert(spec_spells, { -- SHAMAN 1 Elemental 2 Enhancement 3 Restoration
            class = "SHAMAN",
            specs = {
                [1] = { -- Elemental
                    { id = 188443, }, -- Chain Lightning http://www.wowhead.com/spell=188443
                    { id = 196840, }, -- Frost Shock http://www.wowhead.com/spell=196840
                    { id = 51490, }, -- Thunderstorm http://www.wowhead.com/spell=51490
                    { id = 61882, }, -- Earthquake Totem http://www.wowhead.com/spell=61882
                    { id = 198067, }, -- Fire Elemental http://www.wowhead.com/spell=198067
                    { id = 198103, }, -- Earth Elemental http://www.wowhead.com/spell=198103
                    { id = 188196, }, -- Lightning Bolt http://www.wowhead.com/spell=188196
                    { id = 8042, }, -- Earth Shock http://www.wowhead.com/spell=8042
                    { id = 188389, }, -- Flame Shock http://www.wowhead.com/spell=188389
                },
                [2] = { -- Enhancement
                    { id = 196834, }, -- Frostbrand http://www.wowhead.com/spell=196834
                    { id = 51533, }, -- Feral Spirit http://www.wowhead.com/spell=51533
                    { id = 60103, }, -- Lava Lash http://www.wowhead.com/spell=60103
                    { id = 17364, }, -- Stormstrike http://www.wowhead.com/spell=17364
                    { id = 195771, }, -- Maelstrom Controller Decreasing http://www.wowhead.com/spell=195771
                    { id = 193786, }, -- Rockbiter http://www.wowhead.com/spell=193786
                    { id = 193796, }, -- Flametongue http://www.wowhead.com/spell=193796
                    { id = 187837, }, -- Lightning Bolt http://www.wowhead.com/spell=187837
                    { id = 187874, }, -- Crash Lightning http://www.wowhead.com/spell=187874
                    { id = 58875, }, -- Spirit Walk http://www.wowhead.com/spell=58875
                    { id = 188070, }, -- Healing Surge http://www.wowhead.com/spell=188070
                    { id = 16282, }, -- Flurry http://www.wowhead.com/spell=16282
                },
                [3] = { -- Restoration
                    { id = 73920, }, -- Healing Rain http://www.wowhead.com/spell=73920
                    { id = 403, }, -- Lightning Bolt http://www.wowhead.com/spell=403
                    { id = 188838, }, -- Flame Shock http://www.wowhead.com/spell=188838
                    { id = 421, }, -- Chain Lightning http://www.wowhead.com/spell=421
                    { id = 1064, }, -- Chain Heal http://www.wowhead.com/spell=1064
                    { id = 212048, }, -- Ancestral Vision http://www.wowhead.com/spell=212048
                    { id = 5394, }, -- Healing Stream Totem http://www.wowhead.com/spell=5394
                    { id = 77130, }, -- Purify Spirit http://www.wowhead.com/spell=77130
                    { id = 79206, }, -- Spiritwalker's Grace http://www.wowhead.com/spell=79206
                    { id = 77472, }, -- Healing Wave http://www.wowhead.com/spell=77472
                    { id = 98008, }, -- Spirit Link Totem http://www.wowhead.com/spell=98008
                    { id = 108280, }, -- Healing Tide Totem http://www.wowhead.com/spell=108280
                    { id = 61295, }, -- Riptide http://www.wowhead.com/spell=61295
                },
            },
        })
        table.insert(spec_spells, { -- MAGE 1 Arcane 2 Fire 3 Frost
            class = "MAGE",
            specs = {
                [1] = { -- Arcane
                    { id = 110959, }, -- Greater Invisibility http://www.wowhead.com/spell=110959
                    { id = 31589, }, -- Slow http://www.wowhead.com/spell=31589
                    { id = 5143, }, -- Arcane Missiles http://www.wowhead.com/spell=5143
                    { id = 195676, }, -- Displacement http://www.wowhead.com/spell=195676
                    { id = 44425, }, -- Arcane Barrage http://www.wowhead.com/spell=44425
                    { id = 1449, }, -- Arcane Explosion http://www.wowhead.com/spell=1449
                    { id = 30451, }, -- Arcane Blast http://www.wowhead.com/spell=30451
                    { id = 12042, }, -- Arcane Power http://www.wowhead.com/spell=12042
                    { id = 12051, }, -- Evocation http://www.wowhead.com/spell=12051
                    { id = 114664, }, -- Arcane Charge http://www.wowhead.com/spell=114664
                },
                [2] = { -- Fire
                    { id = 2120, }, -- Flamestrike http://www.wowhead.com/spell=2120
                    { id = 133, }, -- Fireball http://www.wowhead.com/spell=133
                    { id = 108853, }, -- Fire Blast http://www.wowhead.com/spell=108853
                    { id = 2948, }, -- Scorch http://www.wowhead.com/spell=2948
                    { id = 31661, }, -- Dragon's Breath http://www.wowhead.com/spell=31661
                    { id = 11366, }, -- Pyroblast http://www.wowhead.com/spell=11366
                    { id = 190319, }, -- Combustion http://www.wowhead.com/spell=190319
                },
                [3] = { -- Frost
                    { id = 116, }, -- Frostbolt http://www.wowhead.com/spell=116
                    { id = 120, }, -- Cone of Cold http://www.wowhead.com/spell=120
                    { id = 12472, }, -- Icy Veins http://www.wowhead.com/spell=12472
                    { id = 84714, }, -- Frozen Orb http://www.wowhead.com/spell=84714
                    { id = 31687, }, -- Summon Water Elemental http://www.wowhead.com/spell=31687
                    { id = 44614, }, -- Flurry http://www.wowhead.com/spell=44614
                    { id = 30455, }, -- Ice Lance http://www.wowhead.com/spell=30455
                    { id = 190356, }, -- Blizzard http://www.wowhead.com/spell=190356
                },
            },
        })
        table.insert(spec_spells, { -- WARLOCK 1 Affliction 2 Demonology 3 Destruction
            class = "WARLOCK",
            specs = {
                [1] = { -- Affliction
                    { id = 172, }, -- Corruption http://www.wowhead.com/spell=172
                    { id = 27243, }, -- Seed of Corruption http://www.wowhead.com/spell=27243
                    { id = 980, }, -- Agony http://www.wowhead.com/spell=980
                    { id = 30108, }, -- Unstable Affliction http://www.wowhead.com/spell=30108
                },
                [2] = { -- Demonology
                    { id = 603, }, -- Doom http://www.wowhead.com/spell=603
                    { id = 686, }, -- Shadow Bolt http://www.wowhead.com/spell=686
                    { id = 105174, }, -- Hand of Gul'dan http://www.wowhead.com/spell=105174
                    { id = 193396, }, -- Demonic Empowerment http://www.wowhead.com/spell=193396
                    { id = 193440, }, -- Demonwrath http://www.wowhead.com/spell=193440
                    { id = 30146, }, -- Summon Felguard http://www.wowhead.com/spell=30146
                    { id = 104316, }, -- Call Dreadstalkers http://www.wowhead.com/spell=104316
                },
                [3] = { -- Destruction
                    { id = 116858, }, -- Chaos Bolt http://www.wowhead.com/spell=116858
                    { id = 348, }, -- Immolate http://www.wowhead.com/spell=348
                    { id = 80240, }, -- Havoc http://www.wowhead.com/spell=80240
                    { id = 29722, }, -- Incinerate http://www.wowhead.com/spell=29722
                    { id = 17962, }, -- Conflagrate http://www.wowhead.com/spell=17962
                    { id = 5740, }, -- Rain of Fire http://www.wowhead.com/spell=5740
                },
            },
        })
        table.insert(spec_spells, { -- MONK 1 Brewmaster 2 Mistweaver 3 Windwalker
            class = "MONK",
            specs = {
                [1] = { -- Brewmaster
                    { id = 115072, }, -- Expel Harm http://www.wowhead.com/spell=115072
                    { id = 121253, }, -- Keg Smash http://www.wowhead.com/spell=121253
                    { id = 115176, }, -- Zen Meditation http://www.wowhead.com/spell=115176
                    { id = 115181, }, -- Breath of Fire http://www.wowhead.com/spell=115181
                    { id = 115203, }, -- Fortifying Brew http://www.wowhead.com/spell=115203
                    { id = 115308, }, -- Ironskin Brew http://www.wowhead.com/spell=115308
                    { id = 205523, }, -- Blackout Strike http://www.wowhead.com/spell=205523
                    { id = 119582, }, -- Purifying Brew http://www.wowhead.com/spell=119582
                },
                [2] = { -- Mistweaver
                    { id = 116849, }, -- Life Cocoon http://www.wowhead.com/spell=116849
                    { id = 115151, }, -- Renewing Mist http://www.wowhead.com/spell=115151
                    { id = 115310, }, -- Revival http://www.wowhead.com/spell=115310
                    { id = 115450, }, -- Detox http://www.wowhead.com/spell=115450
                    { id = 212051, }, -- Reawaken http://www.wowhead.com/spell=212051
                    { id = 191837, }, -- Essence Font http://www.wowhead.com/spell=191837
                    { id = 124682, }, -- Enveloping Mist http://www.wowhead.com/spell=124682
                    { id = 116670, }, -- Vivify http://www.wowhead.com/spell=116670
                    { id = 116680, }, -- Thunder Focus Tea http://www.wowhead.com/spell=116680
                },
                [3] = { -- Windwalker
                    { id = 115080, }, -- Touch of Death http://www.wowhead.com/spell=115080
                    { id = 137639, }, -- Storm, Earth, and Fire http://www.wowhead.com/spell=137639
                    { id = 113656, }, -- Fists of Fury http://www.wowhead.com/spell=113656
                    { id = 101545, }, -- Flying Serpent Kick http://www.wowhead.com/spell=101545
                    { id = 116095, }, -- Disable http://www.wowhead.com/spell=116095
                    { id = 122470, }, -- Touch of Karma http://www.wowhead.com/spell=122470
                },
            },
        })
        table.insert(spec_spells, { -- DRUID 1 Balance 2 Feral 3 Guardian 4 Restoration
            class = "DRUID",
            specs = {
                [1] = { -- Balance
                    { id = 24858, }, -- Moonkin Form http://www.wowhead.com/spell=24858
                    { id = 190984, }, -- Solar Wrath http://www.wowhead.com/spell=190984
                    { id = 191034, }, -- Starfall http://www.wowhead.com/spell=191034
                    { id = 78675, }, -- Solar Beam http://www.wowhead.com/spell=78675
                    { id = 78674, }, -- Starsurge http://www.wowhead.com/spell=78674
                    { id = 197911, }, -- Astral Power http://www.wowhead.com/spell=197911
                    { id = 194153, }, -- Lunar Strike http://www.wowhead.com/spell=194153
                    { id = 194223, }, -- Celestial Alignment http://www.wowhead.com/spell=194223
                },
                [2] = { -- Feral
                    { id = 22568, }, -- Ferocious Bite http://www.wowhead.com/spell=22568
                    { id = 22570, }, -- Maim http://www.wowhead.com/spell=22570
                    { id = 106951, }, -- Berserk http://www.wowhead.com/spell=106951
                    { id = 1079, }, -- Rip http://www.wowhead.com/spell=1079
                    { id = 5217, }, -- Tiger's Fury http://www.wowhead.com/spell=5217
                    { id = 5221, }, -- Shred http://www.wowhead.com/spell=5221
                    { id = 228545, }, -- Cat Form http://www.wowhead.com/spell=228545
                    { id = 1822, }, -- Rake http://www.wowhead.com/spell=1822
                },
                [3] = { -- Guardian
                    { id = 99, }, -- Incapacitating Roar http://www.wowhead.com/spell=99
                    { id = 22842, }, -- Frenzied Regeneration http://www.wowhead.com/spell=22842
                    { id = 6807, }, -- Maul http://www.wowhead.com/spell=6807
                    { id = 33745, }, -- Lacerate http://www.wowhead.com/spell=33745
                    { id = 33917, }, -- Mangle http://www.wowhead.com/spell=33917
                    { id = 192083, }, -- Mark of Ursol http://www.wowhead.com/spell=192083
                    { id = 192081, }, -- Ironfur http://www.wowhead.com/spell=192081
                },
                [4] = { -- Restoration
                    { id = 18562, }, -- Swiftmend http://www.wowhead.com/spell=18562
                    { id = 88423, }, -- Nature's Cure http://www.wowhead.com/spell=88423
                    { id = 102793, }, -- Ursol's Vortex http://www.wowhead.com/spell=102793
                    { id = 740, }, -- Tranquility http://www.wowhead.com/spell=740
                    { id = 8936, }, -- Regrowth http://www.wowhead.com/spell=8936
                    { id = 774, }, -- Rejuvenation http://www.wowhead.com/spell=774
                    { id = 33763, }, -- Lifebloom http://www.wowhead.com/spell=33763
                    { id = 5176, }, -- Solar Wrath http://www.wowhead.com/spell=5176
                    { id = 212040, }, -- Revitalize http://www.wowhead.com/spell=212040
                    { id = 48438, }, -- Wild Growth http://www.wowhead.com/spell=48438
                    { id = 145205, }, -- Efflorescence http://www.wowhead.com/spell=145205
                    { id = 102342, }, -- Ironbark http://www.wowhead.com/spell=102342
                },
            },
        })
        table.insert(spec_spells, { -- DEMONHUNTER 1 Havoc 2 Vengeance
            class = "DEMONHUNTER",
            specs = {
                [1] = { -- Havoc
                },
                [2] = { -- Vengeance
                    { id = 178740, }, -- Immolation Aura http://www.wowhead.com/spell=178740
                    { id = 189110, }, -- Infernal Strike http://www.wowhead.com/spell=189110
                    { id = 207684, }, -- Sigil of Misery http://www.wowhead.com/spell=207684
                    { id = 185245, }, -- Torment http://www.wowhead.com/spell=185245
                    { id = 203720, }, -- Demon Spikes http://www.wowhead.com/spell=203720
                    { id = 203782, }, -- Shear http://www.wowhead.com/spell=203782
                    { id = 228477, }, -- Soul Cleave http://www.wowhead.com/spell=228477
                    { id = 218256, }, -- Empower Wards http://www.wowhead.com/spell=218256
                    { id = 204021, }, -- Fiery Brand http://www.wowhead.com/spell=204021
                    { id = 204157, }, -- Throw Glaive http://www.wowhead.com/spell=204157
                    { id = 202138, }, -- Sigil of Chains http://www.wowhead.com/spell=202138
                    { id = 202137, }, -- Sigil of Silence http://www.wowhead.com/spell=202137
                    { id = 187827, }, -- Metamorphosis http://www.wowhead.com/spell=187827
                    { id = 204596, }, -- Sigil of Flame http://www.wowhead.com/spell=204596
                },
            },
        })
	end

	do -- generate class_talents
        table.insert(class_talents,{ -- warrior
            class = "WARRIOR",
            talents = {
                [1] = { -- spec Arms
                    [1] = {
                        [1] = 202297,
                        [2] = 7384,
                        [3] = 202161,
                    },
                    [2] = {
                        [1] = 46968,
                        [2] = 107570,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 202316,
                        [2] = 772,
                        [3] = 107574,
                    },
                    [4] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 197690,
                    },
                    [5] = {
                        [1] = 215550,
                        [2] = 202593,
                        [3] = 207982,
                    },
                    [6] = {
                        [1] = 227266,
                        [2] = 215538,
                        [3] = 202612,
                    },
                    [7] = {
                        [1] = nil,
                        [2] = 203179,
                        [3] = 152277,
                    },
                },
                [2] = { -- spec Fury
                    [1] = {
                        [1] = 215556,
                        [2] = 202296,
                        [3] = 215568,
                    },
                    [2] = {
                        [1] = 46968,
                        [2] = 107570,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 215569,
                        [2] = nil,
                        [3] = 107574,
                    },
                    [4] = {
                        [1] = 202224,
                        [2] = nil,
                        [3] = 208154,
                    },
                    [5] = {
                        [1] = 206315,
                        [2] = 215571,
                        [3] = 202922,
                    },
                    [6] = {
                        [1] = 12292,
                        [2] = 206313,
                        [3] = 215573,
                    },
                    [7] = {
                        [1] = 46924,
                        [2] = 202751,
                        [3] = 118000,
                    },
                },
                [3] = { -- spec Protection
                    [1] = {
                        [1] = 46968,
                        [2] = 107570,
                        [3] = 103828,
                    },
                    [2] = {
                        [1] = 202168,
                        [2] = 205484,
                        [3] = 223657,
                    },
                    [3] = {
                        [1] = 202288,
                        [2] = 122509,
                        [3] = 107574,
                    },
                    [4] = {
                        [1] = 223662,
                        [2] = nil,
                        [3] = 203201,
                    },
                    [5] = {
                        [1] = 202560,
                        [2] = 202561,
                        [3] = 202095,
                    },
                    [6] = {
                        [1] = 202572,
                        [2] = 202603,
                        [3] = 202743,
                    },
                    [7] = {
                        [1] = nil,
                        [2] = 203177,
                        [3] = 228920,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- mage
            class = "MAGE",
            talents = {
                [1] = { -- spec Arcane
                    [1] = {
                        [1] = 205022,
                        [2] = 205025,
                        [3] = 205035,
                    },
                    [2] = {
                        [1] = 212653,
                        [2] = nil,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 55342,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 157980,
                        [2] = 205032,
                        [3] = 205028,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = 113724,
                        [3] = nil,
                    },
                    [6] = {
                        [1] = 114923,
                        [2] = nil,
                        [3] = 205039,
                    },
                    [7] = {
                        [1] = nil,
                        [2] = 198923,
                        [3] = 153626,
                    },
                },
                [2] = { -- spec Fire
                    [1] = {
                        [1] = 205020,
                        [2] = 205023,
                        [3] = 205026,
                    },
                    [2] = {
                        [1] = 212653,
                        [2] = nil,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 55342,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 157981,
                        [2] = 205029,
                        [3] = 205033,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = 113724,
                        [3] = nil,
                    },
                    [6] = {
                        [1] = 44457,
                        [2] = nil,
                        [3] = 205037,
                    },
                    [7] = {
                        [1] = 155148,
                        [2] = 198929,
                        [3] = 153561,
                    },
                },
                [3] = { -- spec Frost
                    [1] = {
                        [1] = 205021,
                        [2] = 205024,
                        [3] = 205027,
                    },
                    [2] = {
                        [1] = 212653,
                        [2] = nil,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 55342,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 157997,
                        [2] = 205030,
                        [3] = 56377,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = 113724,
                        [3] = nil,
                    },
                    [6] = {
                        [1] = 112948,
                        [2] = nil,
                        [3] = 205038,
                    },
                    [7] = {
                        [1] = 155149,
                        [2] = 199786,
                        [3] = 153595,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- rogue
            class = "ROGUE",
            talents = {
                [1] = { -- spec Assassination
                    [1] = {
                        [1] = 196864,
                        [2] = nil,
                        [3] = 16511,
                    },
                    [2] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 108211,
                        [2] = nil,
                        [3] = nil,
                    },
                    [5] = {
                        [1] = 196861,
                        [2] = nil,
                        [3] = 154904,
                    },
                    [6] = {
                        [1] = 200802,
                        [2] = nil,
                        [3] = nil,
                    },
                    [7] = {
                        [1] = 152152,
                        [2] = nil,
                        [3] = nil,
                    },
                },
                [2] = { -- spec Outlaw
                    [1] = {
                        [1] = 196937,
                        [2] = 200733,
                        [3] = 196938,
                    },
                    [2] = {
                        [1] = 195457,
                        [2] = 196924,
                        [3] = 196922,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 193546,
                        [2] = nil,
                        [3] = nil,
                    },
                    [5] = {
                        [1] = 199743,
                        [2] = nil,
                        [3] = 108216,
                    },
                    [6] = {
                        [1] = 185767,
                        [2] = nil,
                        [3] = 51690,
                    },
                    [7] = {
                        [1] = 5171,
                        [2] = nil,
                        [3] = nil,
                    },
                },
                [3] = { -- spec Subtlety
                    [1] = {
                        [1] = 31223,
                        [2] = 193537,
                        [3] = 200758,
                    },
                    [2] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 200759,
                        [2] = nil,
                        [3] = nil,
                    },
                    [5] = {
                        [1] = 196951,
                        [2] = nil,
                        [3] = 200778,
                    },
                    [6] = {
                        [1] = 196979,
                        [2] = nil,
                        [3] = 206237,
                    },
                    [7] = {
                        [1] = 196976,
                        [2] = nil,
                        [3] = nil,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- warlock
            class = "WARLOCK",
            talents = {
                [1] = { -- spec Affliction
                    [1] = {
                        [1] = 48181,
                        [2] = 196102,
                        [3] = 198590,
                    },
                    [2] = {
                        [1] = 196105,
                        [2] = 196103,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = 6789,
                        [3] = 5484,
                    },
                    [4] = {
                        [1] = nil,
                        [2] = 196226,
                        [3] = nil,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 108416,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [7] = {
                        [1] = nil,
                        [2] = 205179,
                        [3] = nil,
                    },
                },
                [2] = { -- spec Demonology
                    [1] = {
                        [1] = 196269,
                        [2] = 205181,
                        [3] = 205145,
                    },
                    [2] = {
                        [1] = 196270,
                        [2] = 196272,
                        [3] = 196277,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = 6789,
                        [3] = 30283,
                    },
                    [4] = {
                        [1] = 196283,
                        [2] = 196605,
                        [3] = nil,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 108416,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 171975,
                    },
                    [7] = {
                        [1] = 205180,
                        [2] = 157695,
                        [3] = nil,
                    },
                },
                [3] = { -- spec Destruction
                    [1] = {
                        [1] = 196406,
                        [2] = 205184,
                        [3] = 17877,
                    },
                    [2] = {
                        [1] = 205148,
                        [2] = 152108,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = 6789,
                        [3] = 30283,
                    },
                    [4] = {
                        [1] = 196412,
                        [2] = 196408,
                        [3] = nil,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 108416,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [7] = {
                        [1] = 196410,
                        [2] = 196447,
                        [3] = nil,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- priest
            class = "PRIEST",
            talents = {
                [1] = { -- spec Discipline
                    [1] = {
                        [1] = 200347,
                        [2] = nil,
                        [3] = 214621,
                    },
                    [2] = {
                        [1] = 121536,
                        [2] = nil,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 204263,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 123040,
                    },
                    [5] = {
                        [1] = 197419,
                        [2] = 10060,
                        [3] = nil,
                    },
                    [6] = {
                        [1] = 152118,
                        [2] = nil,
                        [3] = 120517,
                    },
                    [7] = {
                        [1] = 204197,
                        [2] = nil,
                        [3] = 204065,
                    },
                },
                [2] = { -- spec Holy
                    [1] = {
                        [1] = 200128,
                        [2] = 200153,
                        [3] = 193155,
                    },
                    [2] = {
                        [1] = 121536,
                        [2] = 214121,
                        [3] = 19236,
                    },
                    [3] = {
                        [1] = 204263,
                        [2] = 200199,
                        [3] = 196707,
                    },
                    [4] = {
                        [1] = 196985,
                        [2] = 200209,
                        [3] = 64901,
                    },
                    [5] = {
                        [1] = 109186,
                        [2] = 32546,
                        [3] = 197034,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 120517,
                    },
                    [7] = {
                        [1] = 200183,
                        [2] = 193157,
                        [3] = 204883,
                    },
                },
                [3] = { -- spec Shadow
                    [1] = {
                        [1] = 109142,
                        [2] = 193195,
                        [3] = 205351,
                    },
                    [2] = {
                        [1] = 193173,
                        [2] = nil,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 205369,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 199849,
                        [2] = 199853,
                        [3] = 205371,
                    },
                    [5] = {
                        [1] = 199855,
                        [2] = 155271,
                        [3] = 162452,
                    },
                    [6] = {
                        [1] = 10060,
                        [2] = 205385,
                        [3] = 200174,
                    },
                    [7] = {
                        [1] = 193225,
                        [2] = 73510,
                        [3] = 193223,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- deathknight
            class = "DEATHKNIGHT",
            talents = {
                [1] = { -- spec Blood
                    [1] = {
                        [1] = 195679,
                        [2] = 221536,
                        [3] = 206931,
                    },
                    [2] = {
                        [1] = 194662,
                        [2] = 212744,
                        [3] = 211078,
                    },
                    [3] = {
                        [1] = 219786,
                        [2] = 221699,
                        [3] = 205727,
                    },
                    [4] = {
                        [1] = 206940,
                        [2] = 205723,
                        [3] = 219809,
                    },
                    [5] = {
                        [1] = 206970,
                        [2] = 206960,
                        [3] = 219779,
                    },
                    [6] = {
                        [1] = 206967,
                        [2] = 194679,
                        [3] = 206974,
                    },
                    [7] = {
                        [1] = 194844,
                        [2] = 206977,
                        [3] = 114556,
                    },
                },
                [2] = { -- spec Frost
                    [1] = {
                        [1] = 207057,
                        [2] = 194878,
                        [3] = 207061,
                    },
                    [2] = {
                        [1] = 207060,
                        [2] = 194909,
                        [3] = 57330,
                    },
                    [3] = {
                        [1] = 207126,
                        [2] = 207127,
                        [3] = 207142,
                    },
                    [4] = {
                        [1] = 207161,
                        [2] = 207167,
                        [3] = 207170,
                    },
                    [5] = {
                        [1] = 207188,
                        [2] = 207200,
                        [3] = 212765,
                    },
                    [6] = {
                        [1] = 207230,
                        [2] = 207104,
                        [3] = 194912,
                    },
                    [7] = {
                        [1] = 207256,
                        [2] = 152279,
                        [3] = 194913,
                    },
                },
                [3] = { -- spec Unholy
                    [1] = {
                        [1] = 194916,
                        [2] = 207264,
                        [3] = 207269,
                    },
                    [2] = {
                        [1] = 207317,
                        [2] = 194917,
                        [3] = 194918,
                    },
                    [3] = {
                        [1] = 207289,
                        [2] = 207305,
                        [3] = 207311,
                    },
                    [4] = {
                        [1] = 207313,
                        [2] = 108194,
                        [3] = 207316,
                    },
                    [5] = {
                        [1] = 207321,
                        [2] = 207319,
                        [3] = 212763,
                    },
                    [6] = {
                        [1] = 198943,
                        [2] = 207346,
                        [3] = 207272,
                    },
                    [7] = {
                        [1] = 207349,
                        [2] = 152280,
                        [3] = 130736,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- druid
            class = "DRUID",
            talents = {
                [1] = { -- spec Balance
                    [1] = {
                        [1] = 205636,
                        [2] = 202425,
                        [3] = 202345,
                    },
                    [2] = {
                        [1] = 108238,
                        [2] = 102280,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 202157,
                        [2] = 197491,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 5211,
                        [2] = 102359,
                        [3] = 132469,
                    },
                    [5] = {
                        [1] = 114107,
                        [2] = 102560,
                        [3] = 202347,
                    },
                    [6] = {
                        [1] = 202342,
                        [2] = 202359,
                        [3] = 202360,
                    },
                    [7] = {
                        [1] = 202770,
                        [2] = 202354,
                        [3] = 202430,
                    },
                },
                [2] = { -- spec Feral
                    [1] = {
                        [1] = 202021,
                        [2] = 202022,
                        [3] = 155580,
                    },
                    [2] = {
                        [1] = 108238,
                        [2] = 102280,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = 217615,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 5211,
                        [2] = 102359,
                        [3] = 132469,
                    },
                    [5] = {
                        [1] = 158476,
                        [2] = 102543,
                        [3] = 52610,
                    },
                    [6] = {
                        [1] = 202031,
                        [2] = 202032,
                        [3] = 202060,
                    },
                    [7] = {
                        [1] = 202028,
                        [2] = 155672,
                        [3] = 155577,
                    },
                },
                [3] = { -- spec Guardian
                    [1] = {
                        [1] = 203953,
                        [2] = 155835,
                        [3] = 203962,
                    },
                    [2] = {
                        [1] = 204012,
                        [2] = 102280,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = 202155,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 5211,
                        [2] = 102359,
                        [3] = 132469,
                    },
                    [5] = {
                        [1] = 158477,
                        [2] = 102558,
                        [3] = 203964,
                    },
                    [6] = {
                        [1] = 203974,
                        [2] = 155578,
                        [3] = 203965,
                    },
                    [7] = {
                        [1] = 204053,
                        [2] = 204066,
                        [3] = 80313,
                    },
                },
                [4] = { -- spec Restoration
                    [1] = {
                        [1] = 200383,
                        [2] = 102351,
                        [3] = 207383,
                    },
                    [2] = {
                        [1] = 108238,
                        [2] = 102280,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 197632,
                        [2] = 197490,
                        [3] = 197491,
                    },
                    [4] = {
                        [1] = 5211,
                        [2] = 102359,
                        [3] = 132469,
                    },
                    [5] = {
                        [1] = 158478,
                        [2] = 33891,
                        [3] = 200390,
                    },
                    [6] = {
                        [1] = 207385,
                        [2] = 197073,
                        [3] = 155675,
                    },
                    [7] = {
                        [1] = 155577,
                        [2] = 197061,
                        [3] = 197721,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- paladin
            class = "PALADIN",
            talents = {
                [1] = { -- spec Holy
                    [1] = {
                        [1] = 223306,
                        [2] = 114158,
                        [3] = 196926,
                    },
                    [2] = {
                        [1] = 230332,
                        [2] = 114154,
                        [3] = 214202,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 115750,
                    },
                    [4] = {
                        [1] = 183425,
                        [2] = 183416,
                        [3] = 183415,
                    },
                    [5] = {
                        [1] = 197646,
                        [2] = 105809,
                        [3] = 114165,
                    },
                    [6] = {
                        [1] = 196923,
                        [2] = 53376,
                        [3] = 183778,
                    },
                    [7] = {
                        [1] = 156910,
                        [2] = 197446,
                        [3] = 200025,
                    },
                },
                [2] = { -- spec Protection
                    [1] = {
                        [1] = 152261,
                        [2] = 204019,
                        [3] = 203785,
                    },
                    [2] = {
                        [1] = 203776,
                        [2] = 204035,
                        [3] = 204023,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 115750,
                    },
                    [4] = {
                        [1] = 204018,
                        [2] = 230332,
                        [3] = 203797,
                    },
                    [5] = {
                        [1] = 213652,
                        [2] = 204139,
                        [3] = 204077,
                    },
                    [6] = {
                        [1] = 204150,
                        [2] = 183778,
                        [3] = 204054,
                    },
                    [7] = {
                        [1] = 204074,
                        [2] = 152262,
                        [3] = 203791,
                    },
                },
                [3] = { -- spec Retribution
                    [1] = {
                        [1] = 198038,
                        [2] = 213757,
                        [3] = 205228,
                    },
                    [2] = {
                        [1] = 203316,
                        [2] = 217020,
                        [3] = 218178,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = 115750,
                    },
                    [4] = {
                        [1] = 202271,
                        [2] = 202270,
                        [3] = 198034,
                    },
                    [5] = {
                        [1] = 215661,
                        [2] = 205191,
                        [3] = 210191,
                    },
                    [6] = {
                        [1] = 213313,
                        [2] = 230332,
                        [3] = 202273,
                    },
                    [7] = {
                        [1] = 223817,
                        [2] = 224668,
                        [3] = 210220,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- shaman
            class = "SHAMAN",
            talents = {
                [1] = { -- spec Elemental
                    [1] = {
                        [1] = 201909,
                        [2] = 170374,
                        [3] = 210643,
                    },
                    [2] = {
                        [1] = nil,
                        [2] = 108281,
                        [3] = 192077,
                    },
                    [3] = {
                        [1] = 192058,
                        [2] = 51485,
                        [3] = 196932,
                    },
                    [4] = {
                        [1] = 117014,
                        [2] = nil,
                        [3] = nil,
                    },
                    [5] = {
                        [1] = 192235,
                        [2] = 117013,
                        [3] = 210714,
                    },
                    [6] = {
                        [1] = 16166,
                        [2] = 192249,
                        [3] = 210707,
                    },
                    [7] = {
                        [1] = 114050,
                        [2] = 210689,
                        [3] = 192222,
                    },
                },
                [2] = { -- spec Enhancement
                    [1] = {
                        [1] = 201898,
                        [2] = 201900,
                        [3] = 201897,
                    },
                    [2] = {
                        [1] = 215864,
                        [2] = 196884,
                        [3] = 192077,
                    },
                    [3] = {
                        [1] = 192058,
                        [2] = 51485,
                        [3] = 196932,
                    },
                    [4] = {
                        [1] = 192106,
                        [2] = nil,
                        [3] = 210853,
                    },
                    [5] = {
                        [1] = 192234,
                        [2] = 210727,
                        [3] = 210731,
                    },
                    [6] = {
                        [1] = 192246,
                        [2] = 197211,
                        [3] = 197214,
                    },
                    [7] = {
                        [1] = 114051,
                        [2] = 197992,
                        [3] = 188089,
                    },
                },
                [3] = { -- spec Restoration
                    [1] = {
                        [1] = 200071,
                        [2] = 73685,
                        [3] = 200072,
                    },
                    [2] = {
                        [1] = nil,
                        [2] = 192088,
                        [3] = 192077,
                    },
                    [3] = {
                        [1] = 192058,
                        [2] = 51485,
                        [3] = 196932,
                    },
                    [4] = {
                        [1] = 197464,
                        [2] = 108281,
                        [3] = 200076,
                    },
                    [5] = {
                        [1] = 207399,
                        [2] = 198838,
                        [3] = 207401,
                    },
                    [6] = {
                        [1] = 197467,
                        [2] = 157153,
                        [3] = 108283,
                    },
                    [7] = {
                        [1] = 114052,
                        [2] = 197995,
                        [3] = 157154,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- demonhunter
            class = "DEMONHUNTER",
            talents = {
                [1] = { -- spec Havoc
                    [1] = {
                        [1] = 192939,
                        [2] = 206475,
                        [3] = 203550,
                    },
                    [2] = {
                        [1] = 203551,
                        [2] = 203555,
                        [3] = 206478,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = 206416,
                        [3] = 206473,
                    },
                    [4] = {
                        [1] = 196555,
                        [2] = 205411,
                        [3] = 204909,
                    },
                    [5] = {
                        [1] = 206476,
                        [2] = 211881,
                        [3] = 206491,
                    },
                    [6] = {
                        [1] = 203556,
                        [2] = 206477,
                        [3] = 193897,
                    },
                    [7] = {
                        [1] = 211048,
                        [2] = 211053,
                        [3] = 213410,
                    },
                },
                [2] = { -- spec Vengeance
                    [1] = {
                        [1] = 207550,
                        [2] = 207548,
                        [3] = 209400,
                    },
                    [2] = {
                        [1] = 207697,
                        [2] = 227174,
                        [3] = 207739,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = 227322,
                        [3] = 211881,
                    },
                    [4] = {
                        [1] = 218612,
                        [2] = 209795,
                        [3] = 217996,
                    },
                    [5] = {
                        [1] = 207666,
                        [2] = 202138,
                        [3] = 209281,
                    },
                    [6] = {
                        [1] = 212084,
                        [2] = 203753,
                        [3] = 218679,
                    },
                    [7] = {
                        [1] = 209258,
                        [2] = 207810,
                        [3] = 227225,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- monk
            class = "MONK",
            talents = {
                [1] = { -- spec Brewmaster
                    [1] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [2] = {
                        [1] = nil,
                        [2] = 116841,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 196721,
                        [2] = 115399,
                        [3] = 196719,
                    },
                    [4] = {
                        [1] = 116844,
                        [2] = 115315,
                        [3] = 119381,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = 122783,
                        [3] = 122278,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = 132578,
                        [3] = 196730,
                    },
                    [7] = {
                        [1] = 196738,
                        [2] = 196736,
                        [3] = 196737,
                    },
                },
                [2] = { -- spec Mistweaver
                    [1] = {
                        [1] = nil,
                        [2] = 124081,
                        [3] = 197945,
                    },
                    [2] = {
                        [1] = nil,
                        [2] = 116841,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 197915,
                        [2] = 210802,
                        [3] = 197900,
                    },
                    [4] = {
                        [1] = 116844,
                        [2] = 198898,
                        [3] = 119381,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = 122783,
                        [3] = 122278,
                    },
                    [6] = {
                        [1] = 196725,
                        [2] = 198664,
                        [3] = 115313,
                    },
                    [7] = {
                        [1] = 197908,
                        [2] = 197895,
                        [3] = 210804,
                    },
                },
                [3] = { -- spec Windwalker
                    [1] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [2] = {
                        [1] = nil,
                        [2] = 116841,
                        [3] = nil,
                    },
                    [3] = {
                        [1] = 115288,
                        [2] = 115396,
                        [3] = 121817,
                    },
                    [4] = {
                        [1] = 116844,
                        [2] = 196722,
                        [3] = 119381,
                    },
                    [5] = {
                        [1] = nil,
                        [2] = 122783,
                        [3] = 122278,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = 123904,
                        [3] = 196740,
                    },
                    [7] = {
                        [1] = 196743,
                        [2] = 152175,
                        [3] = 152173,
                    },
                },
            },
        })
        table.insert(class_talents,{ -- hunter
            class = "HUNTER",
            talents = {
                [1] = { -- spec Beast Mastery
                    [1] = {
                        [1] = 204308,
                        [2] = 194397,
                        [3] = 193532,
                    },
                    [2] = {
                        [1] = 199530,
                        [2] = 217200,
                        [3] = 53209,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 199528,
                        [2] = 194306,
                        [3] = 130392,
                    },
                    [5] = {
                        [1] = 109248,
                        [2] = nil,
                        [3] = 19577,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [7] = {
                        [1] = 201430,
                        [2] = 199532,
                        [3] = nil,
                    },
                },
                [2] = { -- spec Marksmanship
                    [1] = {
                        [1] = 155228,
                        [2] = 193533,
                        [3] = 53238,
                    },
                    [2] = {
                        [1] = 194595,
                        [2] = 194599,
                        [3] = 199527,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 212431,
                        [2] = 206817,
                        [3] = 213423,
                    },
                    [5] = {
                        [1] = 109248,
                        [2] = nil,
                        [3] = 199483,
                    },
                    [6] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [7] = {
                        [1] = 214579,
                        [2] = 198670,
                        [3] = 199522,
                    },
                },
                [3] = { -- spec Survival
                    [1] = {
                        [1] = 204315,
                        [2] = 200163,
                        [3] = 201082,
                    },
                    [2] = {
                        [1] = 206505,
                        [2] = 201075,
                        [3] = 201078,
                    },
                    [3] = {
                        [1] = nil,
                        [2] = nil,
                        [3] = nil,
                    },
                    [4] = {
                        [1] = 194277,
                        [2] = 199518,
                        [3] = 162488,
                    },
                    [5] = {
                        [1] = 191241,
                        [2] = 200108,
                        [3] = 199483,
                    },
                    [6] = {
                        [1] = 212436,
                        [2] = 194855,
                        [3] = 87935,
                    },
                    [7] = {
                        [1] = 194407,
                        [2] = 199543,
                        [3] = nil,
                    },
                },
            },
        })
    end
end

function HCoold:MakeSpellList() -- in future - making self.spells that contains spells, that will be tracking by system by user configuration
	self.spells = {}
	for _,i in next, spells do
		local out = tostring(i.spellID)
		for _,j in next, i.specs do
			out = string.format("%s.%d",out,j)
		end
		if self.db.profile.trackSpells[out] == nil then self.db.profile.trackSpells[out] = true end
		if self.db.profile.trackSpells[out] then
			table.insert(self.spells,i)
		end
	end
end

function HCoold:GetSpecBySpell(spellID) -- return spec of class if it used this spell (check if spell is spec uniq)
	for _,i in next, spec_spells do
		for spec,j in next, i.specs do
			for _,p in next, j do
				if p.id == spellID then return spec end
			end
		end
	end
	return 0
end

local imbaSpell = { -- имба возрождение
				spellID = 20484,
				--succ = {"SPELL_RESURRECT", "SPELL_CAST_SUCCESS", "SPELL_CAST_START"}, -- SPELL_RESURRECT
				--specs = { 0, 1, 2, 3, 4 },
				--CD = 600,
				quality = 3,
				--trigger = { 61999, 20707, },
				type = HCoold.ressurect_type,
				charges = 1,
			}

function HCoold:GetSummaryRessurectSpell()
	-- HCoold:Print("Return summary in spells")
	return imbaSpell
end

function HCoold:GenerateSpellList()
	local out = {}
	local order = 1
	local t_ = {}
	local out2 = {}
	for _, i in next, spells do
		local t = tostring(i.type)
		if not out[t] then -- create group if it's not exists
			out[t] = {
				type = "group",
				cmdHidden = true,
				name = L["type"..t],
				desc = L["desc type"..t],
				order = i.type+30,
				args = {},
			}
			out2[t] = {}
			t_[t] = true
		end
		do -- spell add
			local spname = select(1, GetSpellInfo(i.spellID)) or L["No spell found"]
			local splink = select(1, GetSpellLink(i.spellID))
			local specs = ""
			local tmp = ""
			for _, j in next, i.specs do
				specs = string.format("%s%s%s",specs,tmp,j)
				tmp = ", "
			end
			local desc = function(self)
				GameTooltip:ClearLines()
				if splink then
					GameTooltip:SetHyperlink(splink)
				end
				GameTooltip:AppendText("\n")
				GameTooltip:AppendText(string.format(L["class %s specs %s"],L[i.class],L[i.class .. specs]))
				GameTooltip:AppendText("\n")
				return nil
			end
			local tt = tostring(i.spellID)
			for _,j in next, i.specs do
				tt = string.format("%s.%d",tt,j)
			end
			local s = {
				type = "toggle",
				name = spname,
				desc = desc,
				descStyle = "Toggle",
				set = function(tmp,key)
					self.db.profile.trackSpells[tt] = key
				end,
				get = function()
					return self.db.profile.trackSpells[tt]
				end,
				--order = order,
			}
			--out[t].args[tostring(order)] = s
			--order = order+1
			if not out2[t][i.class] then out2[t][i.class] = {} end
			table.insert(out2[t][i.class],s)
		end
	end
	for t, ss in next, out2 do
		out[t].args.turnoff = {
			type = "execute",
			name = L["turn all off"],
			desc = L["desc turn all off"],
			func = function() for _, i in next, out[t].args do if i.type == "toggle" then i.set(nil,false) end end end,
			order = 1,
		}
		out[t].args.turnon = {
			type = "execute",
			name = L["turn all on"],
			desc = L["desc turn all on"],
			func = function() for _, i in next, out[t].args do if i.type == "toggle" then i.set(nil,true) end end end,
			order = 2,
		}
		local count = 5
		for class, tt in next, ss do
			out[t].args[tostring(count)] = {
				type = "header",
				name = L[class],
				order = count,
			}
			count = count + 1
			for _,i in next, tt do
				i.order = count
				out[t].args[tostring(count)] = i
				count = count + 1
			end
		end
	end

	local sm = {}
	for i,j in next, self.sort_methods do sm[i] = j.desc end
	for i in next, t_ do
		local k_ = (tonumber(i) or 1)
		local k = k_ + 5
		-- self:Printf("%s",k)
		--self:Printf("%s %s %s","width" .. i,k,self.db.profile.types[k].w)
		out["header" .. i] = {
			type = "header",
			cmdHidden = true,
			name = L["header" .. i],
			order = k * 10 + 1
		}
		out["width" .. i] = {
			type = "input",
			cmdHidden = true,
			name = L["type width"..i],
			desc = L["desc type width"..i],
			order = k * 10 + 2,
			width = "half",
			set = function(a1,val)
				val = tonumber(val) or 100
				self.db.profile.types[k_].w = val
				if self.types[k_] then self.types[k_]:SetWidth(val) end
			end,
			get = function()
				return tostring(self.db.profile.types[k_].w)
			end,
		}

		out["sort" .. i] = {
			type = "select",
			-- width = "half",
			name = L["sort method" .. i],
			desc = L["desc sort method" .. i],
			order = k * 10 + 3,
			cmdHidden = true,
			values = sm,
			get = function()
				return self.db.profile.types[k_].sm
			end,
			set = function(tmp, val)
				self.db.profile.types[k_].sm = val
				if self.types[k_] then self.types[k_]:SetSortMethod(val) end
			end,
		}

		out["enable" .. i] = {
			type = "toggle",
			name = L["enable" .. i],
			desc = L["desc enable" .. i],
			order = k*10 + 4,
			cmdHidden = true,
			set = function(t, val)
				self.db.profile.types[k_].enable = val
				if self.types[k_] then self.types[k_]:Enable(val) end
			end,
			get = function() return self.db.profile.types[k_].enable end,
		}
	end

	do -- talent section
		out["auto_talent"] = {
			type = "group",
			cmdHidden = true,
			name = L["talents list"],
			desc = L["desc talents list"],
			order = 20 + 30,
			args = {},
		}
		local order = {
			["DRUID"] = 0,
			["PALADIN"] = 1,
			["PRIEST"] = 2,
			["WARLOCK"] = 3,
			["DEATHKNIGHT"] = 4,
			["MONK"] = 5,
			["HUNTER"] = 6,
			["SHAMAN"] = 7,
			["MAGE"] = 8,
			["WARRIOR"] = 9,
            ["ROGUE"] = 10,
            ["DEMONHUNTER"] = 11,
		}
		local t = out["auto_talent"].args
		t.turnoff = {
			type = "execute",
			name = L["turn all off"],
			desc = L["desc turn all off"],
			func = function() for _, i in next, t do if i.type == "toggle" then i.set(nil,false) end end end,
			order = 1,
		}
		t.turnon = {
			type = "execute",
			name = L["turn all on"],
			desc = L["desc turn all on"],
			func = function() for _, i in next, t do if i.type == "toggle" then i.set(nil,true) end end end,
			order = 2,
		}
		for class, ord in next, order do
			t["header" .. class] = {
				type = "header",
				cmdHidden = true,
				name = L[class],
				order = ord * 30 + 3,
			}
		end
		for k, i in next, list_talents do
			local tt = HCoold:TalentIndex(i)

			local spname = select(1, GetSpellInfo(i.spellID)) or L["No spell found"]
			local splink = select(1, GetSpellLink(i.spellID))
			local desc = function(self)
				GameTooltip:ClearLines()
				if splink then
					GameTooltip:SetHyperlink(splink)
				end
				-- GameTooltip:AppendText("\n")
				-- GameTooltip:AppendText(string.format(L["class %s"],L[i.class]))
				GameTooltip:AppendText(string.format(L["\ntype is %s"],L["type" .. i.type]))
				GameTooltip:AppendText("\n")
				return nil
            end
			t[tt] = {
				type = "toggle",
				name = spname,
				desc = desc,
				descStyle = "Toggle",
				set = function(tmp,key)
					self.db.profile.trackSpells[tt] = key
				end,
				get = function()
					local tmp = self.db.profile.trackSpells[tt]
					if tmp == nil then self.db.profile.trackSpells[tt] = i.turn_on end
					return self.db.profile.trackSpells[tt]
				end,
				order = order[i.class] * 30 + 5,
			}

		end
	end

	return out
end

function HCoold:RunPersonalSpellConfig() -- expert configuration
	local pspells = self.db.faction.PlayersSpells

	local f = AceGUI:Create("Frame")
	local s = AceGUI:Create("ScrollFrame")
	-- local AddLine = nil
	local ann_res = false
	do -- frame creation
		f:SetLayout("Fill")
		f.state = true
		f:SetCallback("OnClose",function(widget)
			f.state = false
			AceGUI:Release(widget)

			if ann_res then
				StaticPopupDialogs["HCooldRedoLayout"]= {
					text = string.format(L["Don't forget to redraw layout to aply settings."]),
					button1 = ACCEPT,
					timeout = 30,
					whileDead = 0,
					hideOnEscape = 1,
				}
				StaticPopup_Show("HCooldRedoLayout")
			end

			HCoold:RunConfig()
		end)
		f:SetTitle(L["Manual spell settings"])

		s:SetLayout("List") -- probably?
		f:AddChild(s)
	end

	do -- create tools to create spell info
		local types, types2 = {}, {}
		for _, i in next, spells do
			if not types[i.type] then
				types[i.type] = L["type" .. i.type]
				types2[i.type] = L["type" .. i.type]
			end
		end
		types[13] = L["talents"]
		--table.sort(types)

		local sg1 = AceGUI:Create("InlineGroup")
		local csg1 = AceGUI:Create("SimpleGroup")
		do -- sg1
			sg1:SetTitle(L["Add new spell options for current player."])
			sg1:SetFullWidth(true)
			sg1:SetLayout("Flow")
			sg1:SetAutoAdjustHeight(true)
			s:AddChild(sg1)
			csg1:SetFullWidth(true)
			csg1:SetLayout("Flow")
			csg1:SetAutoAdjustHeight(true)
		end

		local dd1 = AceGUI:Create("Dropdown") -- types of spell
		local dd2 = AceGUI:Create("Dropdown") -- spell list in this category
		local dd5 = AceGUI:Create("Dropdown") -- type of new spell
		local inp1 = AceGUI:Create("EditBox") -- player name
		local inp2 = AceGUI:Create("EditBox") -- CD in sec
		local inp3 = AceGUI:Create("MultiLineEditBox") -- id of spell
		local inp4 = AceGUI:Create("EditBox") -- casting time
		local inp5 = AceGUI:Create("EditBox") -- trigger event
		local dd3 = AceGUI:Create("Dropdown") -- quality of spell
		local dd4 = AceGUI:Create("Dropdown") -- spec of player to track spell
		local doit = AceGUI:Create("Button") -- button to add spell
		local values = {}
		local splist = {}
		local lines = {}
		local function onValueChanged()
			inp2:SetText()
			inp4:SetText()
			inp5:SetText()
			inp5:Fire("OnEnterPressed")
		end
		do --dd1
			-- sg1:AddChild(dd1)
			dd1:SetList(types)
			dd1:SetWidth(HCoold.config.dropdownwidth)
			dd1:SetCallback("OnValueChanged",function(_,_,key)
				splist = {}
				values = {}
				key = key or 8
				if key ~= 13 then dd5:SetValue(key) end
				dd2:SetValue()
				inp3:SetText("")
				for _, i in next, spells do
					if i.type == key then
						values[i.spellID] = select(1,GetSpellInfo(i.spellID))
						splist[i.spellID] = i
					end
				end
				if key == 13 then
					for _, i in next, list_talents do
						values[i.spellID] = select(1,GetSpellInfo(i.spellID))
						splist[i.spellID] = i
					end
				end
				dd2:SetList(values)
				onValueChanged()
			end)
			dd1:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd1.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Choose category of spell from existsing"])
				GameTooltip:Show()
			end)
			dd1:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			dd1:SetValue(8)
			dd1:Fire("OnValueChanged")
		end
		do -- dd5
			sg1:AddChild(dd5)
			dd5:SetList(types2)
			dd5:SetWidth(HCoold.config.dropdownwidth)
			dd5:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd5.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Choose spell category"])
				GameTooltip:Show()
			end)
			dd5:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			dd5:SetValue(8)
		end
		sg1:AddChild(csg1)
		do --inp3
			inp3:SetWidth(HCoold.config.editboxwidth)
			csg1:AddChild(inp3)
			inp3:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp3.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter id of spell"])
				GameTooltip:Show()
			end)
			inp3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp3:SetCallback("OnEnterPressed",function()
				--onValueChanged()
				lines = {}
				local tmp = ""
				local first = ""
				for i in string.gmatch(inp3:GetText(), "%d+") do
					table.insert(lines,tonumber(i))
					tmp = string.format("%s%s%d",tmp,first,i)
					first = "\n"
				end
				inp3:SetText(tmp)
				--HCoold:Print(inp3:GetText())
			end)
		end
		do --dd2 --------- дописать изъятие кд и прочих вещей из БД
			dd2:SetWidth(HCoold.config.dropdownwidth)
			csg1:AddChild(dd1)
			csg1:AddChild(dd2)
			dd2:SetCallback("OnValueChanged",function(_,_,key)
				onValueChanged()
				local spid = key
				if splist[key].trigger then for _, k in next, splist[key].trigger do spid = string.format("%s\n%d",spid,k) end end
				inp3:SetText(spid)
				dd5:SetValue(splist[key].type)
				inp4:SetText(splist[key].cast_time or 0)
				inp2:SetText(splist[key].CD or 0)
				inp5:SetText(splist[key].succ or "SPELL_CAST_SUCCESS")
			end)
			dd2:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd2.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Choose spell id from existsing"])
				GameTooltip:Show()
			end)
			dd2:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		do --inp1
			inp1:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp1)
			inp1:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp1.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter player name"])
				GameTooltip:Show()
			end)
			inp1:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		do --inp2
			inp2:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp2)
			inp2:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp2.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter CD of spell in sec"])
				GameTooltip:Show()
			end)
			inp2:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp2:SetCallback("OnEnterPressed",function() inp2:SetText(math.max(0,math.ceil(tonumber(inp2:GetText()) or 0))) end)
		end
		do --inp4
			inp4:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp4)
			inp4:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp4.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter casting time of spell"])
				GameTooltip:Show()
			end)
			inp4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp4:SetCallback("OnEnterPressed",function()
				local v = inp4:GetText()
				v = math.max(0,tonumber(v) or 0)
				inp4:SetText(v)
			end)
		end
		do --dd3
			sg1:AddChild(dd3)
			dd3:SetWidth(HCoold.config.dropdownwidth)
			dd3:SetList({1, 2, 3})
			dd3:SetValue(1)
			dd3:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(dd3.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter quality of spell"])
				GameTooltip:Show()
			end)
			dd3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		local spec_list = {"0","1","2","3","1,2","1,3","2,3","1,2,3","1,2,4","1,3,4","2,3,4"}
		do --dd4
			sg1:AddChild(dd4)
			dd4:SetList(spec_list)
			dd4:SetWidth(HCoold.config.dropdownwidth)
			dd4:SetCallback("OnValueChanged",function(_,_,key)
			end)
			dd4:SetCallback("OnEnter",function(self)
				GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
				GameTooltip:AddLine(L["Spec list by class"])
				GameTooltip:Show()
			end)
			dd4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		do --inp5
			inp5:SetWidth(HCoold.config.editboxwidth)
			sg1:AddChild(inp5)
			inp5:SetCallback("OnEnter",function()
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(inp5.frame, "ANCHOR_TOP", 0, 0)
				GameTooltip:AddLine(L["Enter trigger event from combat log"])
				GameTooltip:Show()
			end)
			inp5:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			inp5:SetCallback("OnEnterPressed",function() if inp5:GetText() == "" then inp5:SetText("SPELL_CAST_SUCCESS") end end)
			inp5:Fire("OnEnterPressed")
		end
		do --doit
			doit:SetWidth(HCoold.config.addbuttonwidth)
			doit:SetText(L["Add spell"])
			sg1:AddChild(doit)
			doit:SetCallback("OnEnter",function(self)
				inp3:Fire("OnEnterPressed")
				local splink = GetSpellLink(lines[1] or 0)
				if not splink then return end
				GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
				GameTooltip:SetHyperlink(splink)
				GameTooltip:Show()
			end)
			doit:SetCallback("OnLeave",function() GameTooltip:Hide() end)
		end
		doit:SetCallback("OnClick",function()
			inp2:Fire("OnEnterPressed")
			inp1:Fire("OnEnterPressed")
			inp4:Fire("OnEnterPressed")
			inp5:Fire("OnEnterPressed")
			inp3:Fire("OnEnterPressed")
			local spid, name, cd, casttime, sptype, trigger, quality = lines[1], inp1:GetText(), tonumber(inp2:GetText()) or 0, tonumber(inp4:GetText()) or 0, dd5:GetValue(),inp5:GetText(),dd3:GetValue()
			if cd > 0 and string.len(name) > 0 and spid > 0 and GetSpellInfo(spid) ~= nil then
				local spec_spec = {
					["0"] = { 0 },
					["1"] = { 1 },
					["2"] = { 2 },
					["3"] = { 3 },
					["1,2"] = { 1, 2 },
					["1,3"] = { 1, 3 },
					["2,3"] = { 2, 3 },
					["1,2,3"] = { 1, 2, 3 },
					["1,2,4"] = { 1, 2, 4 },
					["2,3,4"] = { 2, 3, 4 },
					["1,3,4"] = { 1, 3, 4 },
				}
				local i = {
					spellID = spid,
					succ = trigger,
					player = name,
					CD = cd,
					type = sptype,
					cast_time = casttime,
					specs = spec_spec[spec_list[dd4:GetValue() or 1]],
					quality = quality,
				}
				local trigg = {}
				for k = 2, #lines do
					table.insert(trigg,lines[k])
				end
				if #trigg > 0 then i.trigger = trigg end
				table.insert(pspells,i)
				ann_res = true
				AddLine(i)
				f:SetStatusText(L["Cooldown successfully added!"])
			else
				f:SetStatusText(L["You should enter spell id, player name and cooldown of spell."])
			end
		end)
	end

	do -- add List of spells
		local function deleteFromMemory(i)
			for k, j in next, pspells do
				if j == i then
					table.remove(pspells,k)
					f:SetStatusText(L["Cooldown successfulle deleted!"])
				end
			end
		end

		local AddLine = function(i)
			if not i then return end
			local sg2 = AceGUI:Create("InlineGroup")
			sg2:SetLayout("Flow")
			sg2:SetFullWidth(true)
			s:AddChild(sg2)

			local spname,_, spicon = GetSpellInfo(i.spellID)
			if not spname then spname = L["Spell was deleted"] end
			local splink = GetSpellLink(i.spellID) or L["Spell was deleted"]

			local label = AceGUI:Create("InteractiveLabel")
			label:SetImageSize(21,21)
			label:SetFullWidth(true)
			label:SetImage(spicon)
			local specs = ""
			local first
			if i.specs then for _, k in next, i.specs do
				if not first then first = ""
				else first = ", " end
				specs = string.format("%s%s%d",specs,first,k)
			end end
			local out = string.format(L["Spell %s(id=%d, type=%s, quality=%d, specs=%s) for player %s has CD %d sec cast time %.1f and trigger from %s."],
				splink,i.spellID,L["type" .. i.type],i.quality,specs,i.player,i.CD,i.cast_time or 0,i.succ)
			if i.trigger then
				local first, tmp = "", ""
				for _,i in next, i.trigger do
					tmp = string.format("%s%s%d",tmp,first,i)
					first = ", "
				end
				out = out .. string.format(L["another triggers are %s."], tmp)
			end
			label:SetText(out)
			label:SetCallback("OnEnter",function(self)
				GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
				if splink ~= L["Spell was deleted"] then GameTooltip:SetHyperlink(splink)
				else
					GameTooltip:AddLine(L["Spell was deleted desc"])
				end
				GameTooltip:Show()
			end)
			label:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			sg2:AddChild(label)

			local cb = AceGUI:Create("CheckBox")
			sg2:AddChild(cb)
			cb:SetValue(self.db.profile.trackManualSpells[self:ManualSpellIndex(i)])
			cb:SetWidth(HCoold.config.checkboxwidth)
			cb:SetLabel(L["Track spell"])
			cb:SetCallback("OnValueChanged",function()
				self.db.profile.trackManualSpells[self:ManualSpellIndex(i)] = cb:GetValue()
				ann_res = true
			end)

			sg2:SetTitle(string.format(L["Configuration for %s spell"],spname))
			local k = AceGUI:Create("Button")
			k:SetWidth(HCoold.config.deletebuttonwidth)
			k:SetText(L["Delete"])
			sg2:AddChild(k)
			k:SetCallback("OnClick",function()
				StaticPopupDialogs["HCooldAcceptDeleteSpell"]= {
					text = string.format(L["You realy want to delete spell %s?"],spname),
					button1 = ACCEPT,
					button2 = CANCEL,
					timeout = 30,
					whileDead = 0,
					hideOnEscape = 1,
					OnAccept = function()
						k:SetDisabled(true)
						k:SetText(L["Deleted"])
						deleteFromMemory(i)
						ann_res = true
					end,
				}
				StaticPopup_Show("HCooldAcceptDeleteSpell")
			end)
		end

		for _, i in next, pspells do AddLine(i) end
	end

	return f
end

function HCoold:GetTalentSpell(inp)
	local out = {}
	if not self.db.profile.auto_scan_talents then return out end
	if type(inp) == "string" then inp = self:GetSpec(inp) end

	-- и так у нас есть имя игрока, его класс
	-- нам надо взять таланты из памяти
	-- проверить изучил ли он их или нет
	-- включено ли отслеживание аддоном и выдать в массиве
	local t = self.db.faction.AutoTalents[inp.name]
	if t then -- у нас есть таланты по данному игроку
		local ct
		for _, k in next, class_talents do
			if k.class == inp.class then ct = k.talents[inp.spec] end
		end
		-- проходимся по всем талантам
		for i = 1, MAX_TALENT_TIERS do
            if ct[i][t.talents[i]] then -- у нас есть в базе данных этот талант
				local spell = list_talents[ct[i][t.talents[i]]] -- спелл который следует добавить/не добавить
				if spell ~= nil and self.db.profile.trackSpells[self:TalentIndex(spell)] then
					-- и так, спелл отслеживается и у нашего парня есть ->
					table.insert(out,spell)
				end
			end
		end
	end

	return out
end

function HCoold:GetSpecsForClass(class)
	for _, i in next, spec_spells do
		if i.class == class then
			local out = { 0 }
			for i, _ in next, i.specs do table.insert(out, i) end
			table.sort(out)
			return out
		end
	end
end

function HCoold:GetSpellsForSpec(class, spec)
	local out = {}
	-- проверяем общие спеллы по классу
	for _, spell in next, spells do
		if spell.class == class then
			local to_add = false
			for _, i in next, spell.specs do
				if i == 0 then to_add = true end
				if i == spec then to_add = true end
			end
			if to_add then table.insert(out, spell) end
		end
	end
	-- потом добавляем таланты
	for _, spell in next, list_talents do
		if spell.class == class then table.insert(out, spell) end
	end

	return out
end
